import javax.swing.*;  // needed for parameters window
import java.awt.*;
import java.awt.event.*;
import java.io.*;      // needed for file pointers

// class to store all items which need to be globally available 
// used set_ and get_ to distinguish from java library set get 
// This version for SKTcassi (socket I/O to SRT)
public class global
{
    private double pwr[],
        spec[],
        specd[],
        avspec[],
        avspecc[],
        graycorr[],
//        wav[],
//        vamp[],
//        vfstart[],
//        vfstop[],
//        vclos[],
//        vfreq[],
	azscanoff[], elscanoff[], av, avc, vlsr, glat, glon,
	freqsep, intg, bswav, bswsq, bswlast;
    private double freqa,
        freq0,
        restfreq,
        azoff,
        eloff,
        elcor,
        azcor,
        elback,
        calcons,
        beamw,
        curvcorr,
        pscale,
        paver,
        prms,
        pnum,
        rod1,
        rod2,
        rod3,
        rod4,
        rod5,
        azaxis_tilt,
        azfeed_offset,
	azcounts_per_deg, elcounts_per_deg, hacounts_per_deg, mount_dec,
	vscale, peakamp, peakfreq;
    private double azlim1, azlim2, ellim1, ellim2, azstow, elstow, tsys,
	tload, tspill, elaxis_tilt;
    private long tstart;
    private double aznow, elnow, azcmd, elcmd, fcenter, lat, lon;
    private double pazoff, peloff, tilt_az, noisecal;
    private double tdoff, thoff;
    private double sunaz, sunel; //JDL
    private int tnsou; //JDL
    private int refresh,
        fstatus,
	tport,  // JDL socket port, default is 1421
        radiosim,
        azelsim,
        mainten,
        azcount,
        elcount,
        recmode,
        xmark,
        map,
	mancal, match,
	azhboff[], elhboff[], // JDL, for contour map; see procs.java
	south, nfreq, recform, digital, doparams, grid, rpt,
	ptoler, countperstep, pushrod, vsrt, hh90, sg2100, vnum,
	vnumm, vmode, visoc, vwait, debug, nstat, nbas, csum, ptog;

    //JDL dobeep, make a beep
    //logerrs==true if writing errors to a log file
    //oldstamp==true if mtrnew4.bas code in Stamp 1 instead of mtrnew5.bas
    //pref==true if parameter window needs refreshing
    //pvis==true if parameter window is visible
    //npaz true if npoint scan is azimuthal } both true for square grid
    //npel true if npoint scan is elevation }
    //if topk true, set offsets to go to the peak of a npoint scan
    private boolean dobeep, logerrs, logsyserr, oldstamp, pref, pvis,
	npaz, npel, topk;

    private double ras[], decs[], epoc[], xlast[], ylast[], gxlast[];
    private int soutype[];
    private double gylast[], mx[], my[];
    private String sounam[], statnam, version;
    private String ptime = "";
    private String cmdstr = "";
    private String cmdfile = "srt.cmd";
    private String elgfile = "srtelog.txt";
    private String recfile = "default"; // JDL
    private String catfn = "srt.cat"; // JDL
    private String uhomed = "";  // JDL, includes trailing file separator
    private String host = "localhost";  // JDL
    private String os = "unknown";  // JDL
    private int clr, key, hlp, drift, scan, stow, slew, atten, nsou,
	sourn, track, rlo;
    private int ppos, click, mclick, nclick, nsoucat, cmdf, cmdfline, sig,
	bsw, calon, docal, stopproc;
    private int bswcycles, comerr, comerad, nmess;
    {
	 pwr = new double[500];
//         spec = new double[8192];
	 spec = new double[192];
         specd = new double[64];
//         avspec = new double[8192];
//         avspecc = new double[8192];
	 avspec = new double[192];
	 avspecc = new double[192];
//         wav = new double[8192];
//         vamp = new double[10];
//         vclos = new double[10];
//         vfreq = new double[10];
//         vfstart = new double[10];
//         vfstop = new double[10];
	 graycorr = new double[64];
	 azscanoff = new double[257];
	 elscanoff = new double[257];
	 azhboff = new int[257];
	 elhboff = new int[257];
         ras = new double[500];
         decs = new double[500];
         epoc = new double[500];
         sounam = new String[500];
         xlast = new double[501];
         ylast = new double[501];
         gxlast = new double[500];
         gylast = new double[500];
         mx = new double[20];
         my = new double[20];
         soutype = new int[500];
    }
//    private BufferedWriter elout = null;  //JDL
    private PrintStream elout = null;  //JDL
    private PrintStream eps = new PrintStream(System.err);
    public void set_sounam(String name, int index) {
        sounam[index] = name;
    }
    public String get_sounam(int index) {
        return sounam[index];
    }
    public void set_statnam(String name) {
        statnam = name;
    }
    public String get_statnam() {
        return statnam;
    }
    public void set_ver(String ver) {
	version = ver;
    }
    public String get_ver() {
	return version;
    }
    public void set_ptime(String name) {
        ptime = name;
    }
    public String get_ptime() {
        return ptime;
    }
    public void set_cmdstr(String name) {
        cmdstr = name;
    }
    public String get_cmdstr() {
        return cmdstr;
    }
    public void set_catfn(String name) {
	catfn = name;
    }
    public String get_catfn() {
	return catfn;
    }
    public void set_cmdfile(String name) {
        cmdfile = name;
    }
    public String get_cmdfile() {
        return cmdfile;
    }
    public void set_recfile(String name) {
        recfile = name;
    }
    public String get_recfile() {
        return recfile;
    }
    public void set_rpt(int nr) {
	if(nr!=2&&nr!=5&&nr!=10&&nr!=20&&nr!=50&&nr!=100)
	    rpt = 1;
	else
	    rpt = nr;
    }
    public int get_rpt() {
	return rpt;
    }
    public void set_uhomed(String dir) {
	uhomed = dir;
    }
    public String get_uhomed() {
	return uhomed;
    }
    public void set_pwr(double power, int index) {
        pwr[index] = power;
    }
    public double get_pwr(int index) {
        return pwr[index];
    }
    public void set_spec(double power, int index) {
        spec[index] = power;
    }
    public double get_spec(int index) {
        return spec[index];
    }
    public void set_specd(double power, int index) {
        specd[index] = power;
    }
    public double get_specd(int index) {
        return specd[index];
    }
    public void set_avspec(double power, int index) {
        avspec[index] = power;
    }
    public double get_avspec(int index) {
        return avspec[index];
    }
/* VSRT
    public void set_wav(double power, int index) {
        wav[index] = power;
    }
    public double get_wav(int index) {
        return wav[index];
    }
*/
    public void set_avspecc(double power, int index) {
        avspecc[index] = power;
    }
    public double get_avspecc(int index) {
        return avspecc[index];
    }
/* VSRT
    public void set_vamp(double power, int index) {
	vamp[index] = power;
    }
    public double get_vamp(int index) {
	return vamp[index];
    }
    public void set_vclos(double power, int index) {
        vclos[index] = power;
    }
    public double get_vclos(int index) {
        return vclos[index];
    }
    public void set_vfreq(double power, int index) {
        vfreq[index] = power;
    }
    public double get_vfreq(int index) {
        return vfreq[index];
    }
    public void set_vfstart(double power, int index) {
        vfstart[index] = power;
    }
    public double get_vfstart(int index) {
        return vfstart[index];
    }
    public void set_vfstop(double power, int index) {
        vfstop[index] = power;
    }
    public double get_vfstop(int index) {
        return vfstop[index];
    }
*/
    public void set_graycorr(double power, int index) {
        graycorr[index] = power;
    }
    public double get_graycorr(int index) {
        return graycorr[index];
    }
    public void set_azscanoff(double power, int index) {
        azscanoff[index] = power;
    }
    public double get_azscanoff(int index) {
        return azscanoff[index];
    }
    public void set_elscanoff(double power, int index) {
        elscanoff[index] = power;
    }
    public double get_elscanoff(int index) {
        return elscanoff[index];
    }
    public void set_azhboff(int p, int index) {
	azhboff[index] = p;
    }
    public int get_azhboff(int index) {
	return azhboff[index];
    }
    public void set_elhboff(int p, int index) {
	elhboff[index] = p;
    }
    public int get_elhboff(int index) {
	return elhboff[index];
    }
    public void set_ras(double power, int index) {
        ras[index] = power;
    }
    public double get_ras(int index) {
        return ras[index];
    }
    public void set_decs(double power, int index) {
        decs[index] = power;
    }
    public double get_decs(int index) {
        return decs[index];
    }
    public void set_epoc(double power, int index) {
        epoc[index] = power;
    }
    public double get_epoc(int index) {
        return epoc[index];
    }
    public void set_soutype(int i, int index) {
        soutype[index] = i;
    }
    public int get_soutype(int index) {
        return soutype[index];
    }
    public void set_xlast(double p, int index) {
        xlast[index] = p;
    }
    public double get_xlast(int index) {
        return xlast[index];
    }
    public void set_ylast(double p, int index) {
        ylast[index] = p;
    }
    public double get_ylast(int index) {
        return ylast[index];
    }
    public void set_gylast(double p, int index) {
        gylast[index] = p;
    }
    public double get_gylast(int index) {
        return gylast[index];
    }
    public void set_gxlast(double p, int index) {
        gxlast[index] = p;
    }
    public double get_gxlast(int index) {
        return gxlast[index];
    }
    public void set_mx(double p, int index) {
        mx[index] = p;
    }
    public double get_mx(int index) {
        return mx[index];
    }
    public void set_my(double p, int index) {
        my[index] = p;
    }
    public double get_my(int index) {
        return my[index];
    }
    public void set_av(double p) {
        av = p;
    }
    public double get_av() {
        return av;
    }
    public void set_bswav(double p) {
        bswav = p;
    }
    public double get_bswav() {
        return bswav;
    }
    public void set_bswsq(double p) {
        bswsq = p;
    }
    public double get_bswsq() {
        return bswsq;
    }
    public void set_bswlast(double p) {
        bswlast = p;
    }
    public double get_bswlast() {
        return bswlast;
    }
    public void set_vlsr(double p) {
        vlsr = p;
    }
    public double get_vlsr() {
        return vlsr;
    }
    public void set_glat(double p) {
        glat = p;
    }
    public double get_glat() {
        return glat;
    }
    public void set_glon(double p) {
        glon = p;
    }
    public double get_glon() {
        return glon;
    }
    public void set_avc(double p) {
        avc = p;
    }
    public double get_avc() {
        return avc;
    }
    public void set_freqsep(double p) {
        freqsep = p;
    }
    public double get_freqsep() {
        return freqsep;
    }
    public void set_intg(double p) {
        intg = p;
    }
    public double get_intg() {
        return intg;
    }
    public void set_freqa(double p) {
        freqa = p;
    }
    public double get_freqa() {
        return freqa;
    }
    public void set_freq0(double p) {
        freq0 = p;
    }
    public double get_freq0() {
        return freq0;
    }
    public void set_restfreq(double p) {
        restfreq = p;
    }
    public double get_restfreq() {
        return restfreq;
    }
    public void set_azoff(double p) {
        azoff = p;
    }
    public double get_azoff() {
        return azoff;
    }
    public void set_eloff(double p) {
        eloff = p;
    }
    public double get_eloff() {
        return eloff;
    }
    public void set_pazoff(double p) {
        pazoff = p;
    }
    public double get_pazoff() {
        return pazoff;
    }
    public void set_tdoff(double to) {
	tdoff = to;
    }
    public double get_tdoff() {
	return tdoff;
    }
    public void set_thoff(double to) {
	thoff = to;
    }
    public double get_thoff() {
	return thoff;
    }
    public void set_noisecal(double p) {
        noisecal = p;
    }
    public double get_noisecal() {
        return noisecal;
    }
    public void set_peloff(double p) {
        peloff = p;
    }
    public double get_peloff() {
        return peloff;
    }
    public void set_elcor(double p) {
        elcor = p;
    }
    public double get_elcor() {
        return elcor;
    }
    public void set_azcor(double p) {
        azcor = p;
    }
    public double get_azcor() {
        return azcor;
    }
    public void set_elback(double p) {
        elback = p;
    }
    public double get_elback() {
        return elback;
    }
    public void set_calcons(double p) {
        calcons = p;
    }
    public double get_calcons() {
        return calcons;
    }
    public void set_beamw(double p) {
        beamw = p;
    }
    public double get_beamw() {
        return beamw;
    }
    public void set_curvcorr(double p) {
        curvcorr = p;
    }
    public double get_curvcorr() {
        return curvcorr;
    }
    public void set_pscale(double p) {
        pscale = p;
    }
    public double get_pscale() {
        return pscale;
    }
    public void set_paver(double p) {
        paver = p;
    }
    public double get_paver() {
        return paver;
    }
    public void set_prms(double p) {
        prms = p;
    }
    public double get_prms() {
        return prms;
    }
    public void set_pnum(double p) {
        pnum = p;
    }
    public double get_pnum() {
        return pnum;
    }
    public void set_azcounts_per_deg(double p) {
        azcounts_per_deg = p;
    }
    public double get_azcounts_per_deg() {
        return azcounts_per_deg;
    }
    public void set_elcounts_per_deg(double p) {
        elcounts_per_deg = p;
    }
    public double get_elcounts_per_deg() {
        return elcounts_per_deg;
    }
    public void set_hacounts_per_deg(double p) {
        hacounts_per_deg = p;
    }
    public double get_hacounts_per_deg() {
        return hacounts_per_deg;
    }
    public void set_mount_dec(double p) {
        mount_dec = p;
    }
    public double get_mount_dec() {
        return mount_dec;
    }
    public void set_azfeed_offset(double p) {
        azfeed_offset = p;
    }
    public double get_azfeed_offset() {
        return azfeed_offset;
    }
    public void set_azaxis_tilt(double p) {
        azaxis_tilt = p;
    }
    public double get_azaxis_tilt() {
        return azaxis_tilt;
    }
    public void set_elaxis_tilt(double p) {
        elaxis_tilt = p;
    }
    public double get_elaxis_tilt() {
        return elaxis_tilt;
    }
    public void set_tilt_az(double p) {
        tilt_az = p;
    }
    public double get_tilt_az() {
        return tilt_az;
    }
    public void set_azlim1(double p) {
        azlim1 = p;
    }
    public double get_azlim1() {
        return azlim1;
    }
    public void set_azstow(double p) {
        azstow = p;
    }
    public double get_azstow() {
        return azstow;
    }
    public void set_elstow(double p) {
        elstow = p;
    }
    public double get_elstow() {
        return elstow;
    }
    public void set_peakfreq(double p) {
        peakfreq = p;
    }
    public double get_peakfreq() {
        return peakfreq;
    }
    public void set_peakamp(double p) {
        peakamp = p;
    }
    public double get_peakamp() {
        return peakamp;
    }
    public void set_vscale(double p) {
        vscale = p;
    }
    public double get_vscale() {
        return vscale;
    }
    public void set_azlim2(double p) {
        azlim2 = p;
    }
    public double get_azlim2() {
        return azlim2;
    }
    public void set_ellim2(double p) {
        ellim2 = p;
    }
    public double get_ellim2() {
        return ellim2;
    }
    public void set_ellim1(double p) {
        ellim1 = p;
    }
    public double get_ellim1() {
        return ellim1;
    }
    public void set_rod1(double p) {
        rod1 = p;
    }
    public double get_rod1() {
        return rod1;
    }
    public void set_rod2(double p) {
        rod2 = p;
    }
    public double get_rod2() {
        return rod2;
    }
    public void set_rod3(double p) {
        rod3 = p;
    }
    public double get_rod3() {
        return rod3;
    }
    public void set_rod4(double p) {
        rod4 = p;
    }
    public double get_rod4() {
        return rod4;
    }
    public void set_rod5(double p) {
        rod5 = p;
    }
    public double get_rod5() {
        return rod5;
    }
    public void set_tsys(double p) {
        tsys = p;
    }
    public double get_tsys() {
        return tsys;
    }
    public void set_tload(double p) {
        tload = p;
    }
    public double get_tload() {
        return tload;
    }
    public void set_tspill(double p) {
        tspill = p;
    }
    public double get_tspill() {
        return tspill;
    }
    public void set_tstart(long p) {
        tstart = p;
    }
    public long get_tstart() {
        return tstart;
    }
    public void set_aznow(double p) {
        aznow = p;
    }
    public double get_aznow() {
        return aznow;
    }
    public void set_elnow(double p) {
        elnow = p;
    }
    public double get_elnow() {
        return elnow;
    }
    public void set_azcmd(double p) {
        azcmd = p;
    }
    public double get_azcmd() {
        return azcmd;
    }
    public void set_elcmd(double p) {
        elcmd = p;
    }
    public double get_elcmd() {
        return elcmd;
    }
    public void set_fcenter(double p) {
        fcenter = p;
    }
    public double get_fcenter() {
        return fcenter;
    }
    public void set_lat(double p) {
        lat = p;
    }
    public double get_lat() {
        return lat;
    }
    public void set_lon(double p) {
        lon = p;
    }
    public double get_lon() {
        return lon;
    }
    public void set_refresh(int p) {
        refresh = p;
    }
    public int get_refresh() {
        return refresh;
    }
    public void set_rlo(int p) {
	if (p > 30) p = 30;
	if (p < 0) p = 0;
	rlo = p;
    }
    public int get_rlo() {
	return rlo;
    }
    public void set_fstatus(int p) {
        fstatus = p;
    }
    public int get_fstatus() {
        return fstatus;
    }
    public void set_nfreq(int p) {
        nfreq = p;
    }
    public int get_nfreq() {
        return nfreq;
    }
    public void set_radiosim(int p) {
        radiosim = p;
    }
    public int get_radiosim() {
        return radiosim;
    }
    public void set_azelsim(int p) {
        azelsim = p;
    }
    public int get_azelsim() {
        return azelsim;
    }
    public void set_mainten(int p) {
        mainten = p;
    }
    public int get_mainten() {
        return mainten;
    }
    public void set_azcount(int p) {
        azcount = p;
    }
    public int get_azcount() {
        return azcount;
    }
    public void set_elcount(int p) {
        elcount = p;
    }
    public int get_elcount() {
        return elcount;
    }
    public void set_mancal(int p) {
        mancal = p;
    }
    public int get_mancal() {
        return mancal;
    }
    public void set_south(int p) {
        south = p;
    }
    public int get_south() {
        return south;
    }
    public void set_ptoler(int p) {
        ptoler = p;
    }
    public int get_ptoler() {
        return ptoler;
    }
    public void set_countperstep(int p) {
        countperstep = p;
    }
    public int get_countperstep() {
        return countperstep;
    }
    public void set_digital(int p) {
        digital = p;
    }
    public int get_digital() {
        return digital;
    }
    public void set_match(int p) {
	if (p > 2) p = 2;
	if (p < 0) p = 0;
	match = p;
    }
    public int get_match() {
	return match;
    }
    public void set_recmode(int p) {
        recmode = p;
    }
    public int get_recmode() {
        return recmode;
    }
    public void set_recform(int p) {
        recform = p;
    }
    public int get_recform() {
        return recform;
    }
    public void set_xmark(int p) {
        xmark = p;
    }
    public int get_xmark() {
        return xmark;
    }
    public void set_map(int p) {
        map = p;
    }
    public int get_map() {
        return map;
    }
    public void set_docal(int p) {
        docal = p;
    }
    public int get_docal() {
        return docal;
    }
    public void set_stopproc(int p) {
        stopproc = p;
    }
    public int get_stopproc() {
        return stopproc;
    }
    public void set_click(int p) {
        click = p;
    }
    public int get_click() {
        return click;
    }
    public void set_mclick(int p) {
        mclick = p;
    }
    public int get_mclick() {
        return mclick;
    }
    public void set_nclick(int p) {
        nclick = p;
    }
    public int get_nclick() {
        return nclick;
    }
    public void set_ppos(int p) {
        ppos = p;
    }
    public int get_ppos() {
        return ppos;
    }
    public void set_clr(int p) {
        clr = p;
    }
    public int get_clr() {
        return clr;
    }
    public void set_key(int p) {
        key = p;
    }
    public int get_key() {
        return key;
    }
    public void set_hlp(int p) {
        hlp = p;
    }
    public int get_hlp() {
        return hlp;
    }
    public void set_port(int p) {
	tport = p;
    }
    public int get_port() {
	return tport;
    }
    public void set_drift(int p) {
        drift = p;
    }
    public int get_drift() {
        return drift;
    }
    public void set_scan(int p) {
        scan = p;
    }
    public int get_scan() {
        return scan;
    }
    public void set_stow(int p) {
        stow = p;
    }
    public int get_stow() {
        return stow;
    }
    public void set_slew(int p) {
        slew = p;
    }
    public int get_slew() {
        return slew;
    }
    public void set_atten(int p) {
        atten = p;
    }
    public int get_atten() {
        return atten;
    }
    public void set_nsou(int p) {
        nsou = p;
    }
    public int get_nsou() {
        return nsou;
    }
    public void set_sourn(int p) {
        sourn = p;
    }
    public int get_sourn() {
        return sourn;
    }
    public void set_track(int p) {
        track = p;
    }
    public int get_track() {
        return track;
    }
    public void set_nsoucat(int p) {
        nsoucat = p;
    }
    public int get_nsoucat() {
        return nsoucat;
    }
    public void set_cmdf(int p) {
        cmdf = p;
    }
    public int get_cmdf() {
        return cmdf;
    }
    public void set_cmdfline(int p) {
        cmdfline = p;
    }
    public int get_cmdfline() {
        return cmdfline;
    }
    public void set_sig(int p) {
        sig = p;
    }
    public int get_sig() {
        return sig;
    }
    public void set_bsw(int p) {
        bsw = p;
    }
    public int get_bsw() {
        return bsw;
    }
    public void set_bswcycles(int p) {
        bswcycles = p;
    }
    public int get_bswcycles() {
        return bswcycles;
    }
    public void set_comerr(int p) {
        comerr = p;
    }
    public int get_comerr() {
        return comerr;
    }
    public void set_comerad(int p) {
        comerad = p;
    }
    public int get_comerad() {
        return comerad;
    }
    public void set_nmess(int p) {
        nmess = p;
    }
    public int get_nmess() {
        return nmess;
    }
    public void set_calon(int p) {
        calon = p;
    }
    public int get_calon() {
        return calon;
    }
    public void set_pushrod(int p) {
        pushrod = p;
    }
    public int get_pushrod() {
        return pushrod;
    }
    public void set_vsrt(int p) {
        vsrt = p;
    }
    public int get_vsrt() {
        return vsrt;
    }
    public void set_hh90(int p) {
        hh90 = p;
    }
    public int get_hh90() {
        return hh90;
    }
    public void set_sg2100(int p) {
        sg2100 = p;
    }
    public int get_sg2100() {
        return sg2100;
    }
    public void set_vnum(int p) {
        vnum = p;
    }
    public int get_vnum() {
        return vnum;
    }
    public void set_vnumm(int p) {
        vnumm = p;
    }
    public int get_vnumm() {
        return vnumm;
    }
    public void set_vmode(int p) {
        vmode = p;
    }
    public int get_vmode() {
        return vmode;
    }
    public void set_visoc(int p) {
        visoc = p;
    }
    public int get_visoc() {
        return visoc;
    }
    public void set_vwait(int p) {
        vwait = p;
    }
    public int get_vwait() {
        return vwait;
    }
    public void set_debug(int p) {
        debug = p;
    }
    public int get_debug() {
        return debug;
    }
    public void set_nbas(int p) {
        nbas = p;
    }
    public int get_nbas() {
        return nbas;
    }
    public void set_csum(int p) {
        csum = p;
    }
    public int get_csum() {
        return csum;
    }
    public void set_ptog(int p) {
        ptog = p;
    }
    public int get_ptog() {
        return ptog;
    }
    public void set_nstat(int p) {
        nstat = p;
    }
    public int get_nstat() {
        return nstat;
    }
    public void set_beep(boolean b) { //JDL
	dobeep = b;
    }
    public boolean get_beep() { //JDL
	return dobeep;
    }
    public void set_elog(boolean b) { //JDL
	logerrs = b;
    }
    public boolean get_elog() { //JDL
	return logerrs;
    }
    public void set_elgfile(String name) { //JDL
	elgfile = name;
    }
    public String get_elgfile() { //JDL
	return elgfile;
    }
    public PrintStream get_eps() { //JDL
	return eps;
    }
    public void  set_logsyserr(boolean b) { //JDL
	logsyserr = b;
    }



//    public BufferedWriter get_elout() { //JDL
    public PrintStream get_elout() { //JDL
	return elout;
    }
    // create or open error logging file in append mode
//    public BufferedWriter open_elog() { //JDL
    public PrintStream open_elog() { //JDL
	if (elout == null) {
	  try {
//            elout = new BufferedWriter(new FileWriter(uhomed+elgfile, true));
	    elout = new PrintStream(new FileOutputStream(uhomed+elgfile, true));
	  } catch(IOException e) {
	      System.err.println(e);
	  }
	}
	if (logsyserr && elout != null)
	    System.setErr(new PrintStream(elout));
	else
	    System.setErr(eps);
	return elout;
    }
    public void close_elog() { //JDL
	if (elout != null) {
//          try {
	      elout.close();
	      elout = null;
	      System.setErr(eps);
//          } catch(IOException e) {
//              System.out.println(e);
//          }
	}
    }
    public void set_npaz(boolean b) { //JDL
	npaz = b;
    }
    public boolean get_npaz() { //JDL
	return npaz;
    }
    public void set_npel(boolean b) { //JDL
	npel = b;
    }
    public boolean get_npel() { //JDL
	return npel;
    }
    public void set_stamp(boolean b) { //JDL
	oldstamp = b;
    }
    public boolean get_stamp() { //JDL
	return oldstamp;
    }
    public void set_topk(boolean b) { //JDL
	topk = b;
    }
    public boolean get_topk() { //JDL
	return topk;
    }
    public void set_pref(boolean b) { //JDL
	pref = b;
    }
    public boolean get_pref() { //JDL
	return pref;
    }
    public void set_pvis(boolean b) { //JDL
	pvis = b;
    }
    public boolean get_pvis() { //JDL
	return pvis;
    }
    public void set_doparams(int p) { //JDL
	doparams = p;
    }
    public int get_doparams() { //JDL
	return doparams;
    }
    public void set_sunaz(double p) { //JDL
	sunaz = p;
    }
    public double get_sunaz() { //JDL
	return sunaz;
    }
    public void set_sunel(double p) { //JDL
	sunel = p;
    }
    public double get_sunel() { //JDL
	return sunel;
    }
    public void set_tnsou(int i) { //JDL
	tnsou = i;
    }
    public int get_tnsou() { //JDL
	return tnsou;
    }
    public void set_grid(int p) { //JDL
	if(p!=3&&p!=5&&p!=7&&p!=9&&p!=11)
	    grid = 5;
	else
	    grid = p;
    }
    public int get_grid() { //JDL
	return grid;
    }
    public int get_smax() { //JDL
	return grid * grid;
    }
    public void set_os(String o) { //JDL
	os = o;
    }
    public String get_os() { //JDL
	return os;
    }
    public void set_host(String h) { //JDL
	host = h;
    }
    public String get_host() { //JDL
	return host;
    }



}
