import java.awt.*;
public class map
// draws the npoint grid contour map
// the power measured at each point is found by g.get_pwr(j)
// where j >= 1 and j <= max points
{
    void map(global g, disp d, Graphics gg, outfile out) {
	int i, iter, j, nnfreq, x, y, mx, my, py[], px;
	int npts, nrows; // JDL
	double sum, sumdm, summm, aa, bb, az, el, a, b, mmax, max,
	    min, dx, dy, azwid, elwid;
	double hsf, sf, ra; //JDL, to allow different grids
	double[] sm = new double[100]; // JDL, for a line scan

	py = new int[100];
	max = mmax = -1e29;
	min = 1e29;
	px = 0;
	mx = my = 0;
	sum = sumdm = summm = 0;
	if (g.get_npaz() && g.get_npel())
	    npts = g.get_smax();
	else
	    npts = g.get_grid();
	nrows = g.get_grid();
	ra = 0.25 * g.get_beamw() * ((double)nrows - 1.0);
	// show a crude scale; had to modify plots.plotp() so this
	// would not get wiped out
	d.dtext(268.0, 110.0, gg, Color.black, "0");
	if (ra >= 10.0) {
	    d.dtext(208.0, 110.0, gg, Color.black, "-"+d.dc(ra, 2, 0));
	    d.dtext(308.0, 110.0, gg, Color.black, "+"+d.dc(ra, 2, 0));
	} else {
	    d.dtext(208.0, 110.0, gg, Color.black, "-"+d.dc(ra, 3, 1));
	    d.dtext(308.0, 110.0, gg, Color.black, "+"+d.dc(ra, 3, 1));
	}
	d.pclear(gg, 662.0, 380.0, 100.0, 30.0); // clears peak reporting area
	// for a 5x5 grid, sf was 0.05; see below
	sf = 0.01 * (double)nrows;
	hsf = 0.5 * sf;
	// find max, min powers
	for (i = 0; i < npts; i++) {
            if (g.get_pwr(i + 1) > max)
                max = g.get_pwr(i + 1);
            if (g.get_pwr(i + 1) < min)
                min = g.get_pwr(i + 1);
	}
	mx = my = 0;
	azwid = elwid = 0.0; // peak FWHMs in pixels
	// the map is 100 pixels wide and 99 pixels high
	// this is also (nrows - 1)/2 beamwidths
	// power at each point is the sum of all npts powers
	// multiplied by the antenna resolution (1/x)*sin(x)
	// appropriate to each point (convolution)

	if (g.get_npaz() && g.get_npel()) { // 2D code
	    for (iter = 0; iter < 3; iter++) {
		for (x = -50; x < 50; x++) {
		    for (y = -50; y < 49; y++) {
			sum = 0.0;
			for (i = 0; i < npts; i++) {
			    // loop thru all data points & see what
			    // they contribute at point (x, y) on graph
			    // index is i+1 as data points are stored with
			    // indices from 1 to npts; see procs.java
			    // az, el are converted to 1/2 beamw so the
			    // the (1/x)sin(x) can be used (data points
			    // are spaced by 1/2 beamw)
			    //az = 2.0 * g.get_azscanoff(i + 1) / g.get_beamw();
			    //el = 2.0 * g.get_elscanoff(i + 1) / g.get_beamw();
			    // Use the offsets in half beamw created in procs.java
			    az = g.get_azhboff(i + 1);
			    el = g.get_elhboff(i + 1);
			    // x, y are the positions in pixels from center
			    // of plot area as origin.
			    // Data points spaced by 1/2 beamw are also
			    // spaced by 20 pixels, on a 5x5 grid.
			    // Thus dx = x * 0.05 - az is the distance
			    // in 1/2 beamw between a point at x on the
			    // plot and a data point whose offset is az.
			    // For a 9x9 grid, for example, data points
			    // would be spaced by 100/9 pixels, which
			    // means dx = x * 0.09 - az.
			    dx = x * sf - az; // convert to 1/2 beamw units
			    dy = y * sf - el;
/*
			    a = 0.8 * dx * Math.PI;
			    b = 0.8 * dy * Math.PI;
			    if (a == 0.0)
				a = 1.0;
			    else
				a = Math.sin(a) / a;
			    if (b == 0.0)
				b = 1.0;
			    else
				b = Math.sin(b) / b;
			    sum += a * b * (g.get_pwr(i + 1) - min);
*/
			    a = 2.0*J1XoverX(3.0*Math.sqrt(dx*dx+dy*dy));
			    sum += a * a * (g.get_pwr(i + 1) - min);

			    // if iter == 2 the contour map has been drawn
			    // & the FWHMs (in pixels) have been calculated;
			    // see note at botton of file for what comes next
			    if (iter == 2 && x == mx && y == my && azwid > 0
				&& elwid > 0) {
				a = dx / (azwid * hsf); // convert each width
				b = dy / (elwid * hsf); // to 1/2 beamw units
				bb = (a * a + b * b) * 0.7;
				aa = Math.pow(2.718, -bb);
//   System.out.println(" aa "+aa+" pwr "+(g.get_pwr(i+1)-min)+" i "+i+" "+az+" "+el);
				if (aa > 0.1) {
				    sumdm += aa * (g.get_pwr(i + 1) - min);
				    summm += aa * aa;
				}
			    }
			} // have done all points for a given x, y
			// a is the pwr for a given x, y from the
			// contributions of all data points
			// a will change from iter == 0 to iter == 1,
			// but not from iter == 1 to iter == 2.
			a = sum;
			if (a > mmax) {
			    mmax = a;
			    mx = x;
			    my = y;
			}
			// mmax is the greatest power we have found
			// so far and it is at mx, my;
			// when iter == 1 we know mmax is indeed the
			// maximum so we can draw the contour map
			if (iter == 1) {
			    i = (int) ((a / mmax) * 7.0);
			    j = 0;
			    if (i < 0)
				i = 0;
			    if (i > 7)
				i = 7;
			    if (i <= 2)
				j = i;
			    if (i == 3)
				j = 4;
			    if (i == 4)
				j = 9;
			    if (i == 5)
				j = 10;
			    if (i == 6)
				j = 12;
			    if (i == 7)
				j = 15;
			    if ((i != py[y + 50] || i != px) && x > -50 && y > -50)
				j = 15;
			    // Seven colors are used.
			    // This uses a color of maximum saturation and
			    // brightness with hue specified by the decimal
			    // fraction part of the floating point number
			    // j/15. See java documentation.
			    d.rpaint(gg,
				     Color.getHSBColor((float) j / (float) 15.0, (float) 1.0, (float) 1.0),
				     (double) x + 50.0 + 219.0, 49.0 - (double) y);
			    py[y + 50] = i;
			    px = i;
			    if (a >= mmax * 0.5 && x == mx)
				elwid++;
			    if (a >= mmax * 0.5 && y == my)
				azwid++;
			}
		    } // have gone through all y values, -> next x
		} // now all x values, -> next iter
	    } // finally all three iters
	    mmax = sumdm / (summm + 1e-6);
	    if (g.get_digital() > 0)
		nnfreq = g.get_nfreq() - 2*g.get_rlo();
	    else
		nnfreq = g.get_nfreq();
	    g.set_azoff(g.get_beamw() * 0.5 * sf * mx / Math.cos(g.get_elcmd() * Math.PI / 180.0));
	    g.set_eloff(g.get_beamw() * 0.5 * sf * my);
	    // normalized highest contour is mmax and it is found at
	    // az=g.get_azoff() and el=g.get_eloff(), which are in degrees
	    // from the source coordinates
	    d.dtext(665.0, 378.0, gg, Color.black, "Scan results:");
	    d.dtext(664.0, 392.0, gg, Color.black,
		    "max " + d.dc((mmax / (double) nnfreq), 5, 0) +
		    " at " + d.dc(g.get_azoff(), 5, 1) + " "
		    + d.dc(g.get_eloff(), 5, 1) + " deg");
	    d.dtext(664.0, 406.0, gg, Color.black,
		    "fwhm: az " + d.dc(azwid * sf * g.get_beamw(), 5, 1) +
		    " el " + d.dc(elwid * sf * g.get_beamw(), 5, 1) + " deg");
	    if (g.get_fstatus() == 1)
		out.stroutfile(g,
		    "* NPOINT max " + d.dc(((mmax + min) / (double) nnfreq), 5, 0) +
		    " at " + d.dc(g.get_azoff(), 5, 1) + " " + d.dc(g.get_eloff(), 5, 1));
	} else { // 1D scan, plot it along the x direction
	    d.pclear(gg, 219.0, 0.0, 100.0, 99.0);
	    for (iter = 0; iter < 3; iter++) {
		for (x = -50; x < 50; x++) {
		    sum = 0.0;
		    for (i = 0; i < npts; i++) {
//                        if (g.get_npel())
//                            az = 2.0 * g.get_elscanoff(i + 1) / g.get_beamw();
//                        else
//                            az = 2.0 * g.get_azscanoff(i + 1) / g.get_beamw();
//                        dx = x * sf - az;
			dx = (double)x * sf - g.get_azhboff(i + 1);
/*
			a = 0.8 * dx * Math.PI;
			if (a == 0.0)
			    a = 1.0;
			else
			    a = Math.sin(a) / a;
*/
			a = 2.0*J1XoverX(3.0*dx);

			sum += a * a * (g.get_pwr(i + 1) - min);
			if (iter == 2 && x == mx && azwid > 0) {
			    a = dx / (azwid * hsf);
			    bb = (a * a) * 0.7;
			    aa = Math.pow(2.718, -bb);
			    if (aa > 0.1) {
				sumdm += aa * (g.get_pwr(i + 1) - min);
				summm += aa * aa;
			    }
			}
		    } // have done all points for given x
		    a = sum; // reuse variable a
		    if (a > mmax) {
			mmax = a;
			mx = x;
		    }
		    if (iter == 1) { // draws the graph, finds azwid
			ra = 64.0 * a / mmax;  // borrow a variable
			d.rpaint(gg, Color.blue,
			    (double) x + 269.0, 82.0 - ra);
			if (a > 0.5 * max) azwid++;
		    }
		} // now all x values done, -> next iter
	    } // finally all three iters are done
	    mmax = sumdm / (summm + 1e-6);
	    if (g.get_digital() > 0)
		nnfreq = g.get_nfreq() - 20;
	    else
		nnfreq = g.get_nfreq();
	    d.dtext(665.0, 378.0, gg, Color.black, "Scan results:");
	    if (g.get_npaz()) {
		g.set_azoff(g.get_beamw() * 0.5 * sf * mx / Math.cos(g.get_elcmd() * Math.PI / 180.0));
		g.set_eloff(0.0);
		d.dtext((double)237.0, (double)12.0, gg,  Color.black, "Azimuth Scan");
		d.dtext(670.0, 392.0, gg, Color.black,
		    "max " + d.dc((mmax / (double) nnfreq), 5, 0) +
		    " at " + d.dc(g.get_azoff(), 5, 1) +" deg");
		d.dtext(670.0, 406.0, gg, Color.black, "(fwhm "
		    + d.dc(azwid * sf * g.get_beamw(), 5, 1) + " deg)");
	    }
	    if (g.get_npel()) {
		g.set_eloff(g.get_beamw() * 0.5 * sf * my);
		g.set_azoff(0.0);
		d.dtext((double)232.0, (double)12.0, gg,  Color.black, "Elevation Scan");
		d.dtext(670.0, 392.0, gg, Color.black,
		    "max " + d.dc((mmax / (double) nnfreq), 5, 0) +
		    " at " + d.dc(g.get_eloff(), 5, 1) +" deg");
		d.dtext(670.0, 406.0, gg, Color.black, "(fwhm "
		    + d.dc(azwid * sf * g.get_beamw(), 5, 1) + " deg)");
	    }
	    if (g.get_fstatus() == 1)
		out.stroutfile(g,
		    "* NPOINT max " + d.dc(((mmax + min) / (double) nnfreq), 5, 0) +
		    " at " + d.dc(g.get_azoff(), 5, 1) + " " + d.dc(g.get_eloff(), 5, 1));
	}
    }

    // From Numerical Recipes in C, page 233;
    // recipe also has a part for |x| > 8, not used here.

    public double J1XoverX(double x) {
	double y, num, den;

	if (x == 0.0) {
	    return(0.5);
	}
	if (x >= 8.0 || x <=-8.0) {
	    return(0.0);
	}
	y = x*x;
	num = 72362614232.0+y*(-7895059235.0+y*(242396853.1
	    +y*(-2972611.439+y*(15704.48260+y*(-30.16036606)))));
	den = 144725228442.0+y*(2300535178.0+y*(1858330.74
	    +y*(99447.43394+y*(376.9991397+y*(1.0)))));
	return(num/den);
    }

}


/* Note about signal normalization.

   For each of the 10,000 points (x, y) in the contour plot and
   each of the NxN data points where the signal was measured, we
//   calculate [(1/dx)sin(dx)]*[(1/dy)sin(dy)]*[pwr(x, y) - p_min].
//   The first zeros of the sin() occur when dx or dy is
//   about 1.25.
   calculate {[(2*J1(x)/x]^2}*[pwr(x, y) - p_min] where
   x = 3*sqrt(dx^2+dy^2). The first zero of J1() occurs when
   sqrt(dx^2_dy^2) is about 1.25.
   The distances dx, dy to the data point are measured in units
   of 1/2 beamw, about 3.5 deg.

   These numbers added up for all of the data points to give a
   number sum(x, y). The largest number sum(mx, my) is located
   and the HWHMs of the peak hwx and hwy (in units of 1/2 beamw)
   are also found.

   The colored contour map is a plot of sum(x, y). On the final
   pass through the loop (iter == 2) a number aa(mx, my; az, el)
   is found for the peak point and the data point at (az, el).
   of [pwr(mx, my) - p_min] is calculated as

   aa(mx, my; az, el) =
     exp{-(dx/hwx)*(dx*hwx)/sqrt(2)} * exp{-(dx/hwx)*(dx*hwx)/sqrt(2)}

   This is used to provide a Gaussian weighted contribution at (mx, my)
   for each data point that is

   c(mx, my; az, el) = aa(mx, my; az, el) * [pwr(mx, my) - p_min]

   and a contribution to a normalizing factor that is

   n(mx, my; az, el) = aa(mx, my; az, el) * aa(mx, my; az, el)

   The c(mx, my; az, el) are added for all data points to get
   sumdm(mx, my) and the n(mx, my; az, el) are added to get
   summm(mx, my). The plotted peak height was sum(mx, my) the
   plot is scaled to fit) but the number reported on the screen
   as the peak height is sum(mx, my) * sumdm(mx, my) / summ(mx, my)


*/
