import java.io.*;
import java.awt.*;
import java.lang.*;

// writes the output file
public class outfile
{
    private BufferedWriter out;
    private String str, fname;
    private int i, year, day, hour, min, secc;
    private double sec;
    private time t;
    public outfile(time tt) {
        t = tt;
    }
    void openoutfile(global g, disp d, Graphics gg)
    {
        try {
            sec = (double) t.getTsec(g, d, gg);
            fname = t.getYdh() + ".rad";
            str = g.get_recfile();
	    if (!str.equalsIgnoreCase("default") && str.length() > 2) {
		fname = str; // keep existing file
                if (str.indexOf(".rad") == -1 && str.indexOf(".RAD") == -1)
                    fname += ".rad";
            }
            g.set_recfile(fname);
	    // open/create for appending
//KH	Changed file so that the .rad file is created from the home directory
            out = new BufferedWriter(new FileWriter(g.get_uhomed() + fname, true));
            g.set_fstatus(1);
            d.set_bc(Color.green, 11);
	    if (g.get_pvis())
		g.set_pref(true);
            str =
                "* STATION LAT=" + d.dc((g.get_lat() * 180.0 / Math.PI), 7, 2) +
		" DEG LONG=" + d.dc((g.get_lon() * (-180.0) / Math.PI), 7, 2);
//JDL            if (g.get_recmode() != 1)
	    {
                out.write(str);
		out.newLine();
		out.write("* ROLLOFF = " + g.get_rlo());
//JDL              out.newLine();
		out.write(", Mode 4 MATCH = " + g.get_match());
		out.newLine();
		out.write("* Each line is the average of "+g.get_rpt()+" scans"); // JDL
		out.newLine();
		out.write("* starting recording v>=2.00"); // JDL
		out.newLine();
	    }
	    str = "*  yr:day:hr:mn:sc Az_deg El_deg DAz_dg DEl_dg MHz   Pwr Source";
	    if (g.get_vsrt() != 0 && g.get_recmode() != 1) {
                out.write(str);
		out.newLine();
	    }
	    d.ppclear(gg, 665.0, 501.0, 280.0);
	    d.stext(665.0, 501.0, gg, Color.red, "recording: " + g.get_recfile());
            if (g.get_azaxis_tilt() != 0.0 || g.get_elaxis_tilt() != 0.0) {
                str =
                    "* AZTILT=" + d.dc(g.get_azaxis_tilt(), 7, 2) +
                    " TILTAZ=" + d.dc(g.get_tilt_az(), 7, 2) +
		    " ELTILT=" + d.dc(g.get_elaxis_tilt(), 7, 2);
//JDL                if (g.get_recmode() != 1)
		{
                    out.write(str);
		    out.newLine();
		}
            }
	    out.flush();
        }
        catch(IOException e) {
            System.out.println(e);
            g.set_fstatus(-1);
	    g.set_recfile("default"); //JDL
        }
    }

    // writes a line of data from SRT
    void writeoutfile(global g, disp d, Graphics gg) {
	String str4 = " "; // field separator
        if ((g.get_recform() & 1) == 1)
            str4 = "\t";
	if ((g.get_recform() & 8) == 8)
	    str4 = ",";
        t.getTsec(g, d, gg);
        try {
	    if (g.get_rpt() > 1) { // JDL
		out.write("* average of "+g.get_rpt()+" scans");
		out.newLine();
	    }
	    str = t.getYdhms() + str4 + d.dc(g.get_aznow(), 6, 1) + str4 +
                d.dc(g.get_elnow(), 5, 1) + str4 +
                d.dc(g.get_azoff(), 5, 1) + str4 + d.dc(g.get_eloff(), 5, 1) + str4 +
		//KH: added line to print out galactic coordinates in the .rad file		
		d.dc(g.get_glon(), 5, 1) + str4 + d.dc(g.get_glat(),5,1) + str4 +           
		d.dc(g.get_freq0(), 8, 2);
            out.write(str);
            if (g.get_digital() > 0) {
                str = str4 + d.dc(g.get_freqsep(), 10, 8) + str4 +
                    d.dc((double) g.get_digital(), 3, 0) + str4 + d.dc((double) g.get_nfreq(), 3, 0);
                out.write(str);
            }
            for (i = 0; i < g.get_nfreq(); i++)
                out.write(str4 + d.dc(g.get_spec(i), 5, 1));
            if (g.get_recmode() == 2 || (g.get_recform() & 2) == 2)
                out.write(str4 + "vlsr" + str4 + d.dc(g.get_vlsr(), 8, 2));
	    out.newLine();
	    out.flush();
	    d.ppclear(gg, 665.0, 501.0, 280.0);
	    d.stext(665.0, 501.0, gg, Color.red, "recording: " + g.get_recfile());
        }
        catch(IOException e) {
            System.out.println(e);
            g.set_fstatus(-1);
            g.set_recfile("");
        }
    }

    void stroutfile(global g, String str) {
        try {
//JDL            if (g.get_recmode() != 1)
	    {
		out.write(str);
		out.newLine();
		out.flush();
	    }
        }
        catch(IOException e) {
            System.out.println(e);
            g.set_fstatus(-1);
            g.set_recfile("");
        }
    }

    void closeoutfile(global g, disp d, Graphics gg) {
        try {
	    out.write("* stopping recording"); //JDL
	    out.newLine();
            out.close();
            d.set_bc(Color.black, 11);
            g.set_fstatus(0);
	    d.ppclear(gg, 665.0, 501.0, 140.0);
            g.set_click(0);
//            g.set_recfile("default");
// JDL so one can turn recording on/off & keep file name
        }
        catch(IOException e) {
            System.out.println(e);
            g.set_fstatus(-1);
	    g.set_recfile("default"); // JDL
        }
	if (g.get_pvis()) //JDL
	    g.set_pref(true);
    }
}
