// displays the value of selected parameters
// and allows users to change them
import javax.swing.*;
import java.awt.*;
import java.awt.color.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import java.lang.Double;
import java.io.*;

public class params
{

    private static DecimalFormat outF1;
    private static DecimalFormat outS3;
//    private static DecimalFormat outI3;
    private static JTextField sazField;  // sun azimuth
    private static JLabel sazLabel;
    private static JTextField selField;  // sun elevation
    private static JLabel selLabel;
    private static JTextField tazField;  // Test  azimuth
    private static JLabel tazLabel;
    private static JTextField telField;  // Test elevation
    private static JLabel telLabel;
    private static JTextField paoField;  // paxoff
    private static JLabel paoLabel;
    private static JTextField peoField;  // peloff
    private static JLabel peoLabel;
    private static JTextField tdoField;  // tdoff
    private static JLabel tdoLabel;
    private static JTextField thoField;  // thoff
    private static JLabel thoLabel;
    private static JTextField ccField;  // calcons
    private static JLabel ccLabel;
    private static JTextField cvField;  // curvcorr
    private static JLabel cvLabel;
    private static JTextField tsField;  // tsys
    private static JLabel tsLabel;
    private static JTextField ntField;  // noisecal
    private static JLabel ntLabel;
    private static JTextField catField; // custom cat file
    private static JLabel catLabel;
    private static JLabel homeLabel;
    private static JRadioButton cmdBut; // command file
    private static JTextField cmdField;
    private static JRadioButton logBut; // error logging
    private static JTextField logField;
    private static JRadioButton recBut; // recording
    private static JTextField recField;
    private static JLabel fsLabel;      // output field separator
    private static JRadioButton tabBut; // tab field separator
    private static JRadioButton comBut; // comma field separator
    private static JRadioButton spcBut; // space field separator
    private static ButtonGroup ofsGroup;
    public static JButton saveChangeBut;
    public static JButton catfBut;
    private static JPanel pane;
    private static JMenuBar pMenuBar;
    private static JRadioButtonMenuItem stepOne, stepTwo, stepFiv, stepBig;
    private static JRadioButtonMenuItem grid3, grid5, grid7, grid9, grid11;
    private static JRadioButtonMenuItem npGrid, npAz, npEl;
    private static JRadioButtonMenuItem rptOne, rptTwo, rptFiv, rptTen,
	rptTty, rptFty, rptHun;
// probably a bad idea to allow roll-off change except by .cat file
//    private static JRadioButtonMenuItem roff8, roff10, roff12, roff14;
    private static ButtonGroup stepGrp, gridGrp, rptGrp;

    private static Font myFont = new Font("Monospaced", 0, 12);

    private static boolean npaz, nnpaz, npel, nnpel, peak, npeak;
    private static int cps, cscale, ncps, grid, ngrid, rmode, rpt, nrpt;
    private static double tras, tdecs;
    private static String calc, curv, syst, noiset, pao, peo, taz, tel;
    private static String cfile, lfile, rfile;

    public static JFrame myFrame;

    public JFrame makeFrame(final global g, final disp d, final outfile of, final cat c) {

	myFrame = new JFrame("View/Change Selected Parameters:");
	Component contents = createComponents(g, d, of, c);
	pMenuBar = createMenuBar(g);
	myFrame.setJMenuBar(pMenuBar);
	myFrame.getContentPane().add(contents, BorderLayout.CENTER);
	myFrame.pack();
	return myFrame;
    }

    private Component createComponents(final global g, final disp d, final outfile of, final cat c) {

//        outI3 = new DecimalFormat("###");
	outF1 = new DecimalFormat("#0.0");
	outS3 = new DecimalFormat("0.###E0");
	outS3.setMinimumFractionDigits(3);

	fsLabel = new JLabel("Field separator: ", JLabel.RIGHT);
	tabBut = new JRadioButton("tab");
	comBut = new JRadioButton("comma");
	spcBut = new JRadioButton("space");
	ofsGroup = new ButtonGroup();
	ofsGroup.add(tabBut);
	ofsGroup.add(comBut);
	ofsGroup.add(spcBut);
	tabBut.setSelected(true);
	JPanel fsPane = new JPanel();
	fsPane.setLayout(new BoxLayout(fsPane, BoxLayout.X_AXIS));
	fsPane.add(Box.createHorizontalGlue());
	fsPane.add(fsLabel);
	fsPane.add(tabBut);
	fsPane.add(comBut);
	fsPane.add(spcBut);

	rmode = g.get_recmode();
	if ((rmode | 1) == 1) tabBut.setSelected(true);
	else if ((rmode | 8) == 8) comBut.setSelected(true);
	else spcBut.setSelected(true);

	ccLabel = new JLabel("calcons: ", JLabel.RIGHT);
	ccField = new JTextField((calc=outS3.format(g.get_calcons())), 10);
	ccField.setMaximumSize(new Dimension(100, 24));
	ccField.setHorizontalAlignment(JTextField.RIGHT);
	ccField.setFont(myFont);
	JPanel ccPane = new JPanel();
	ccPane.setLayout(new BoxLayout(ccPane, BoxLayout.X_AXIS));
	ccPane.add(Box.createHorizontalGlue());
	ccPane.add(ccLabel);
	ccPane.add(ccField);

	cvLabel = new JLabel("curvcor: ", JLabel.RIGHT);
	cvField = new JTextField((curv=outS3.format(g.get_curvcorr())), 10);
	cvField.setMaximumSize(new Dimension(100, 24));
	cvField.setHorizontalAlignment(JTextField.RIGHT);
	cvField.setFont(myFont);
	JPanel cvPane = new JPanel();
	cvPane.setLayout(new BoxLayout(cvPane, BoxLayout.X_AXIS));
	cvPane.add(Box.createHorizontalGlue());
	cvPane.add(cvLabel);
	cvPane.add(cvField);

	ntLabel = new JLabel("noisecal: ", JLabel.RIGHT);
	ntField = new JTextField((noiset=outF1.format(g.get_noisecal())), 10);
	ntField.setMaximumSize(new Dimension(100, 24));
	ntField.setHorizontalAlignment(JTextField.RIGHT);
	ntField.setFont(myFont);
	JPanel ntPane = new JPanel();
	ntPane.add(Box.createHorizontalGlue());
	ntPane.setLayout(new BoxLayout(ntPane, BoxLayout.X_AXIS));
	ntPane.add(Box.createHorizontalGlue());
	ntPane.add(ntLabel);
	ntPane.add(ntField);

	tsLabel = new JLabel("tsys: ", JLabel.RIGHT);
	tsField = new JTextField((syst=outF1.format(g.get_tsys())), 10);
	tsField.setMaximumSize(new Dimension(100, 24));
	tsField.setHorizontalAlignment(JTextField.RIGHT);
	tsField.setFont(myFont);
	JPanel tsPane = new JPanel();
	tsPane.setLayout(new BoxLayout(tsPane, BoxLayout.X_AXIS));
	tsPane.add(Box.createHorizontalGlue());
	tsPane.add(tsLabel);
	tsPane.add(tsField);

	sazLabel = new JLabel("Sun az (deg): ", JLabel.RIGHT);
	sazField = new JTextField(outF1.format(g.get_sunaz()), 10);
	sazField.setMaximumSize(new Dimension(100, 24));
	sazField.setHorizontalAlignment(JTextField.RIGHT);
	sazField.setFont(myFont);
	sazField.setEditable(false);
	JPanel sazPane = new JPanel();
	sazPane.setLayout(new BoxLayout(sazPane, BoxLayout.X_AXIS));
	sazPane.add(Box.createHorizontalGlue());
	sazPane.add(sazLabel);
	sazPane.add(sazField);

	selLabel = new JLabel("Sun el (deg): ", JLabel.RIGHT);
	selField = new JTextField(outF1.format(g.get_sunel()), 10);
	selField.setMaximumSize(new Dimension(100, 24));
	selField.setHorizontalAlignment(JTextField.RIGHT);
	selField.setFont(myFont);
	selField.setEditable(false);
	JPanel selPane = new JPanel();
	selPane.setLayout(new BoxLayout(selPane, BoxLayout.X_AXIS));
	selPane.add(Box.createHorizontalGlue());
	selPane.add(selLabel);
	selPane.add(selField);

	tazLabel = new JLabel("TEST az (deg): ", JLabel.RIGHT);
	tazField = new JTextField("", 10);
	tazField.setMaximumSize(new Dimension(100, 24));
	tazField.setHorizontalAlignment(JTextField.RIGHT);
	tazField.setFont(myFont);
	tazField.setEditable(false);
	if (g.get_tnsou() >= 0) {
	    tras = (180.0/Math.PI)*(g.get_ras(g.get_tnsou()));
	    tazField.setText((taz=outF1.format(tras)));
	    tazField.setEditable(true);
	}
	JPanel tazPane = new JPanel();
	tazPane.setLayout(new BoxLayout(tazPane, BoxLayout.X_AXIS));
	tazPane.add(Box.createHorizontalGlue());
	tazPane.add(tazLabel);
	tazPane.add(tazField);

	telLabel = new JLabel("TEST el (deg): ", JLabel.RIGHT);
	telField = new JTextField("", 10);
	telField.setMaximumSize(new Dimension(100, 24));
	telField.setHorizontalAlignment(JTextField.RIGHT);
	telField.setFont(myFont);
	telField.setEditable(false);
	if (g.get_tnsou() >= 0) {
	    tdecs = (180.0/Math.PI)*(g.get_decs(g.get_tnsou()));
	    telField.setText((tel=outF1.format(tdecs)));
	    telField.setEditable(true);
	}
	JPanel telPane = new JPanel();
	telPane.setLayout(new BoxLayout(telPane, BoxLayout.X_AXIS));
	telPane.add(Box.createHorizontalGlue());
	telPane.add(telLabel);
	telPane.add(telField);

	paoLabel = new JLabel("pazoff: ", JLabel.RIGHT);
	paoField = new JTextField((pao=outF1.format(g.get_pazoff())), 10);
	paoField.setMaximumSize(new Dimension(100, 24));
	paoField.setHorizontalAlignment(JTextField.RIGHT);
	paoField.setFont(myFont);
	JPanel paoPane = new JPanel();
	paoPane.setLayout(new BoxLayout(paoPane, BoxLayout.X_AXIS));
	paoPane.add(Box.createHorizontalGlue());
	paoPane.add(paoLabel);
	paoPane.add(paoField);

	peoLabel = new JLabel("peloff: ", JLabel.RIGHT);
	peoField = new JTextField((peo=outF1.format(g.get_peloff())), 10);
	peoField.setMaximumSize(new Dimension(100, 24));
	peoField.setHorizontalAlignment(JTextField.RIGHT);
	peoField.setFont(myFont);
	JPanel peoPane = new JPanel();
	peoPane.setLayout(new BoxLayout(peoPane, BoxLayout.X_AXIS));
	peoPane.add(Box.createHorizontalGlue());
	peoPane.add(peoLabel);
	peoPane.add(peoField);

	tdoLabel = new JLabel("toff (days): ", JLabel.RIGHT);
	tdoField = new JTextField((outF1.format(g.get_tdoff())), 10);
	tdoField.setMaximumSize(new Dimension(100, 24));
	tdoField.setHorizontalAlignment(JTextField.RIGHT);
	tdoField.setFont(myFont);
	if (g.get_azelsim() < 0)
	    tdoField.setEditable(true);
	else
	    tdoField.setEditable(false);
	JPanel tdoPane = new JPanel();
	tdoPane.setLayout(new BoxLayout(tdoPane, BoxLayout.X_AXIS));
	tdoPane.add(Box.createHorizontalGlue());
	tdoPane.add(tdoLabel);
	tdoPane.add(tdoField);

	thoLabel = new JLabel("toff (hrs): ", JLabel.RIGHT);
	thoField = new JTextField((outF1.format(g.get_thoff())), 10);
	thoField.setMaximumSize(new Dimension(100, 24));
	thoField.setHorizontalAlignment(JTextField.RIGHT);
	thoField.setFont(myFont);
	if (g.get_azelsim() < 0)
	    thoField.setEditable(true);
	else
	    thoField.setEditable(false);
	JPanel thoPane = new JPanel();
	thoPane.setLayout(new BoxLayout(thoPane, BoxLayout.X_AXIS));
	thoPane.add(Box.createHorizontalGlue());
	thoPane.add(thoLabel);
	thoPane.add(thoField);

	JPanel numPane = new JPanel();
	numPane.setLayout(new GridLayout(0, 2, 72, 10));
	numPane.add(tsPane);
	numPane.add(ntPane);
	numPane.add(ccPane);
	numPane.add(cvPane);
	numPane.add(paoPane);
	numPane.add(peoPane);
	numPane.add(tdoPane);
	numPane.add(thoPane);
	numPane.add(tazPane);
	numPane.add(telPane);
	numPane.add(sazPane);
	numPane.add(selPane);

	cmdBut = new JRadioButton("Command file name: ");
	cmdBut.setSelected(g.get_cmdf() == 1);
	cfile = new String(g.get_cmdfile());
	cmdField = new JTextField(cfile, 32);
//        cmdField.setMaximumSize(new Dimension(320, 24));
	cmdField.setFont(myFont);
	JPanel cmdPane = new JPanel();
	cmdPane.setLayout(new BoxLayout(cmdPane, BoxLayout.X_AXIS));
	cmdPane.add(cmdBut);
	cmdPane.add(cmdField);
	cmdPane.add(Box.createHorizontalGlue());

	lfile = new String(g.get_elgfile());
	logBut = new JRadioButton("Log errors to file: ");
	logBut.setSelected(g.get_elog());
	logField = new JTextField(lfile, 32);
	logField.setMaximumSize(new Dimension(320, 24));
	logField.setFont(myFont);
	JPanel logPane = new JPanel();
	logPane.setLayout(new BoxLayout(logPane, BoxLayout.X_AXIS));
	logPane.add(logBut);
	logPane.add(logField);
	logPane.add(Box.createHorizontalGlue());

	catLabel = new JLabel("Cat File: ");
	catField = new JTextField(g.get_catfn(), 32);
	catField.setMaximumSize(new Dimension(320, 24));
	catField.setFont(myFont);
	catfBut = new JButton("Load File");
	catfBut.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		File catf;
		String newfn;
		newfn = catField.getText();
		if (newfn.equals(g.get_catfn()))
		    return;
		catf = new File(newfn);
		if (catf.isFile() == false) {
		    catField.setText("Cannot open "+newfn);
		    return;
		}
		g.set_catfn(newfn);
		c.catfile(g, d, d.getGraphics());
		g.set_clr(-1);
	    }
	});
	JPanel catPane = new JPanel();
	catPane.setLayout(new BoxLayout(catPane, BoxLayout.X_AXIS));
	catPane.add(Box.createRigidArea(new Dimension(12, 0)));
	catPane.add(catLabel);
	catPane.add(catField);
	catPane.add(catfBut);
	catPane.add(Box.createHorizontalGlue());

	recBut = new JRadioButton("Record data to file: ");
	recBut.setSelected(g.get_fstatus() == 1);
	rfile = new String(g.get_recfile());
	recField = new JTextField(rfile, 32);
	recField.setMaximumSize(new Dimension(300, 24));
	recField.setFont(myFont);
	JPanel recPane = new JPanel();
	recPane.setLayout(new BoxLayout(recPane, BoxLayout.X_AXIS));
	recPane.add(recBut);
	recPane.add(recField);
//        recPane.add(Box.createHorizontalGlue());

	// this does most of the work
	saveChangeBut = new JButton("Save Changes");
	saveChangeBut.setForeground(Color.magenta.darker());
	saveChangeBut.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String tmps;
		int nmode = rmode;
		double tnum, toff;
		boolean rec = (g.get_fstatus() == 1);
		JMenu gm0 = pMenuBar.getMenu(0); // this cruft is to
		JMenuItem g3 = gm0.getItem(0);   // get pointers right
		JMenuItem g5 = gm0.getItem(1);
		JMenuItem g7 = gm0.getItem(2);
		JMenuItem g9 = gm0.getItem(3);
		JMenuItem g11 = gm0.getItem(4);
		// separator in here
		JMenuItem npg = gm0.getItem(6);
		JMenuItem npa = gm0.getItem(7);
		JMenuItem npe = gm0.getItem(8);
		// separator in here
		JMenuItem tp = gm0.getItem(10);
		JMenu gm1 = pMenuBar.getMenu(1);
		JMenuItem s1 = gm1.getItem(0);
		JMenuItem s2 = gm1.getItem(1);
		JMenuItem s5 = gm1.getItem(2);
		JMenuItem sb = gm1.getItem(3);
//                JMenu gm2 = pMenuBar.getMenu(2);
//                JMenuItem r8 = gm1.getItem(0);
//                JMenuItem r10 = gm1.getItem(1);
//                JMenuItem r12 = gm1.getItem(2);
//                JMenuItem r14 = gm1.getItem(3);
		JMenu gm3 = pMenuBar.getMenu(2);
		JMenuItem r1 = gm3.getItem(0);
		JMenuItem r2 = gm3.getItem(1);
		JMenuItem r5 = gm3.getItem(2);
		JMenuItem r10 = gm3.getItem(3);
		JMenuItem r20 = gm3.getItem(4);
		JMenuItem r50 = gm3.getItem(5);

		// first take care of outfile
		if (rec) {
		    if (recBut.isSelected() == false
			|| rfile.equals(recField.getText()) == false) {
			of.closeoutfile(g, d, d.getGraphics());
			rec = false;
		    }
		}
		if (rfile.equals(recField.getText()) == false)
		    g.set_recfile(recField.getText());
		if (recBut.isSelected()) {
		    of.openoutfile(g, d, d.getGraphics());
		    rec = (g.get_fstatus() == 1);
		}

		// then the output modes
		if (tabBut.isSelected()) {
		    nmode |= 1;
		    nmode &= ~8;
		} else if (comBut.isSelected()) {
		    nmode |= 8;
		    nmode &= ~1;
		} else {
		    nmode &= ~9;
		}
		if (nmode != rmode) {
		    g.set_recmode(nmode);
		    if (rec)
			of.stroutfile(g, "* recmode: "+rmode+" -> "+nmode);
		}

		// next the error logging file
		if (g.get_elout() != null) {
		    if (logBut.isSelected() == false
			|| lfile.equals(logField.getText()) == false) {
			g.close_elog();
			g.set_elog(false);
			if (rec)
			    of.stroutfile(g, "* closed error log "+lfile);
		    }
		}
		if (lfile.equals(logField.getText()) == false)
		    g.set_elgfile(logField.getText());

		if (logBut.isSelected()) {
		    g.set_elog(true);
		    g.open_elog();
		    if (rec)
			of.stroutfile(g, "* using error log "+logField.getText());
		}

		// next the command file
		if (g.get_cmdf() == 1) {
		    if (cmdBut.isSelected() == false
			|| cfile.equals(cmdField.getText()) == false) {
			g.set_cmdf(0);
			g.set_cmdfline(0);
			d.set_bc(Color.black, 12);
			if (rec)
			    of.stroutfile(g, "* closed command file "+cfile);
		    }
		}
		if (cfile.equals(cmdField.getText()) == false)
		    g.set_cmdfile(cmdField.getText());
		if (cmdBut.isSelected()) {
		    g.set_cmdf(1);
		    g.set_cmdfline(0);
		    d.set_bc(Color.green, 12);
		    if (rec)
			of.stroutfile(g, "* using command file "+cmdField.getText());
		}

		// now the various constants
		tmps = tsField.getText();
		if (syst.equals(tmps) == false)
		    try {
			g.set_tsys(Double.parseDouble(tmps));
			if (rec)
			    of.stroutfile(g, "* tsys: "+syst+" -> "+tmps);
		    } catch(NumberFormatException ex) { }
		tmps = ntField.getText();
		if (noiset.equals(tmps) == false)
		    try {
			g.set_noisecal(Double.parseDouble(tmps));
			if (rec)
			    of.stroutfile(g, "* noisecal: "+noiset+" -> "+tmps);
		    } catch(NumberFormatException ex) { }
		tmps = ccField.getText();
		if (calc.equals(tmps) == false)
		try {
		    g.set_calcons(Double.parseDouble(tmps));
		    if (rec)
			of.stroutfile(g, "* calcons: "+calc+" -> "+tmps);
		} catch(NumberFormatException ex) { }
		tmps = cvField.getText();
		if (curv.equals(tmps) == false)
		    try {
			g.set_curvcorr(Double.parseDouble(tmps));
			if (rec)
			    of.stroutfile(g, "* curvcorr: "+curv+" -> "+tmps);
		    } catch(NumberFormatException ex) { }
		tmps = paoField.getText();
		if (pao.equals(tmps) == false)
		    try {
			tnum = (double)Math.round(10.0*Double.parseDouble(tmps))
				/ 10.0;
			if (tnum > 30.0) tnum = 30.0;
			if (tnum < -30.0) tnum = -30.0;
			g.set_pazoff(tnum);
			if (rec)
			    of.stroutfile(g, "* pazoff: "+pao+" -> "+outF1.format(tnum));
		    } catch(NumberFormatException ex) { }
		tmps = peoField.getText();
		if (peo.equals(tmps) == false)
		    try {
			tnum = (double)Math.round(10.0*Double.parseDouble(tmps))
				/ 10.0;
			if (tnum > 30.0) tnum = 30.0;
			if (tnum < -30.0) tnum = -30.0;
			g.set_peloff(tnum);
			if (rec)
			   of.stroutfile(g, "* peloff: "+peo+" -> "+outF1.format(tnum));
		    } catch(NumberFormatException ex) { }
		if (g.get_tnsou() >= 0) {
		    tmps = tazField.getText();
//System.out.println("tnsou is "+g.get_tnsou());
//System.out.println("tmps: "+tmps);
//System.out.println("taz: "+taz);
		    if (taz.equals(tmps) == false) {
			try {
			    tnum = (double)Math.round(10.0*Double.parseDouble(tmps))
				    / 10.0;
			    if (tnum > 350.0) tnum = 350.0;
			    if (tnum < 5.0) tnum = 5.0;
			    g.set_ras(tnum*Math.PI/180.0, g.get_tnsou());
			    if (rec)
				of.stroutfile(g, "* TESTaz: "+taz+" -> "+outF1.format(tnum));
//                            taz = tmps;
			} catch(NumberFormatException ex) { }
		    }
		    tmps = telField.getText();
		    if (tel.equals(tmps) == false) {
			try {
			    tnum = (double)Math.round(10.0*Double.parseDouble(tmps))
				    / 10.0;
			    if (tnum > 85.0) tnum = 85.0;
			    if (tnum < 5.0) tnum = 5.0;
			    g.set_decs(tnum*Math.PI/180.0, g.get_tnsou());
			    if (rec)
				of.stroutfile(g, "* TESTel: "+tel+" -> "+outF1.format(tnum));
//                            tel = tmps;
			} catch(NumberFormatException ex) { }
		    }
		}
		tmps = tdoField.getText();
		if (g.get_azelsim() < 0) {
		    try {
			tnum = (double)Math.round(10.0*Double.parseDouble(tmps))
				/ 10.0;
			if (tnum > 1000.0) tnum = 1000.0;
			if (tnum < -1000.0) tnum = -1000.0;
			toff = g.get_tdoff();
			if (toff != tnum) {
			    g.set_tdoff(tnum);
			    if (rec)
				of.stroutfile(g, "* tdoff: "
				    + outF1.format(toff) +" -> "+outF1.format(tnum));
			}
		    } catch(NumberFormatException ex) { }
		    tmps = thoField.getText();
		    try {
			tnum = (double)Math.round(10.0*Double.parseDouble(tmps))
				/ 10.0;
			if (tnum > 168.0) tnum = 168.0;
			if (tnum < -168.0) tnum = -168.0;
			toff = g.get_thoff();
			if (toff != tnum) {
			    g.set_thoff(tnum);
			    if (rec)
				of.stroutfile(g, "* thoff: "
				    + outF1.format(toff) +" -> "+outF1.format(tnum));
			}
		    } catch(NumberFormatException ex) { }
		}
		if (s1.isSelected()) {ncps = cscale;}
		else if (s2.isSelected()) {ncps = 2*cscale;}
		else if (s5.isSelected()) {ncps = 5*cscale;}
		else {ncps = 10000;}
		if (cps != ncps) {
		    g.set_countperstep(ncps);
		    if (rec)
		       of.stroutfile(g, "* countperstep: "+cps+" -> "+ncps);
		}
/*
		if (r8.isSelected()) {nroff = 8;}
		else if (r12.isSelected()) {nroff = 12;}
		else if (r14.isSelected()) {nroff = 14;}
		else {nroff = 10;}
		if (nroff != roff) {
		    g.set_rlo(nroff);
		    if (rec)
		       of.stroutfile(g, "* roll-off: "+roff+" -> "+nroff);
		}
*/
		if (g.get_scan() == 0) {
		    if (g3.isSelected()) {ngrid = 3;}
		    else if (g7.isSelected()) {ngrid = 7;}
		    else if (g9.isSelected()) {ngrid = 9;}
		    else if (g11.isSelected()) {ngrid = 11;}
		    else {ngrid = 5;}
		    if (grid != ngrid) {
			g.set_grid(ngrid);
			if (rec)
			   of.stroutfile(g, "* npoint rows/cols: "+grid+" -> "+ngrid);
		    }
		    if (r1.isSelected()) {nrpt = 1;}
		    else if (r2.isSelected()) {nrpt = 2;}
		    else if (r5.isSelected()) {nrpt = 5;}
		    else if (r10.isSelected()) {nrpt = 10;}
		    else if (r20.isSelected()) {nrpt = 20;}
		    else {nrpt = 50;}
		    if (rpt != nrpt) {
			g.set_rpt(nrpt);
			if (rec) {
			   of.stroutfile(g, "* scans/line: "+rpt+" -> "+nrpt);
			   of.stroutfile(g, "* Each line is the average of "
				+ nrpt + " scans");
			}
		    }
		    if (npa.isSelected() && !npe.isSelected())
			{nnpaz = true; nnpel = false;}
		    else if (!npa.isSelected() && npe.isSelected())
			{nnpaz = false; nnpel = true;}
		    else
			{nnpaz = nnpel = true;}
		    if (npaz != nnpaz) {
			g.set_npaz(nnpaz);
			if (rec) {
			    if (nnpaz)
			       of.stroutfile(g, "* npoint npaz  -> true");
			    else
			       of.stroutfile(g, "* npoint npaz  -> false");
			}
		    }
		    if (npel != nnpel) {
			g.set_npel(nnpel);
			if (rec) {
			    if (nnpel)
			       of.stroutfile(g, "* npoint npel  -> true");
			    else
			       of.stroutfile(g, "* npoint npel  -> false");
			}
		    }
		    npeak = tp.isSelected();
		    if (peak != npeak) {
			g.set_topk(npeak);
			if (rec) {
			    if (npeak)
			       of.stroutfile(g, "* npoint to peak  -> true");
			    else
			       of.stroutfile(g, "* npoint to peak  -> false");
			}
		    }
		}


		g.set_doparams(1); // so srt.java will close window
		g.set_pref(false);
	    }
	});

	JPanel svPane = new JPanel();
	svPane.setLayout(new BoxLayout(svPane, BoxLayout.X_AXIS));
	homeLabel = new JLabel("$HOME=" + g.get_uhomed());
	svPane.add(homeLabel);
	svPane.add(Box.createHorizontalGlue());
	svPane.add(saveChangeBut);
	svPane.add(Box.createRigidArea(new Dimension(0, 32)));

//        JPanel hmPane = new JPanel();
//        hmPane.setLayout(new BoxLayout(hmPane, BoxLayout.X_AXIS));
//        homeLabel = new JLabel("$HOME=" + g.get_uhomed());
//        hmPane.add(homeLabel);
//        hmPane.add(Box.createHorizontalGlue());
//        hmPane.add(Box.createRigidArea(new Dimension(0, 32)));


	// now combine everything into one pane
	JPanel contentPane = new JPanel();
	contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
	contentPane.add(Box.createRigidArea(new Dimension(0, 10)));
	contentPane.add(cmdPane);
	contentPane.add(Box.createRigidArea(new Dimension(0, 10)));
	contentPane.add(recPane);
	contentPane.add(fsPane);
	contentPane.add(Box.createRigidArea(new Dimension(0, 10)));
	contentPane.add(logPane);
	contentPane.add(Box.createRigidArea(new Dimension(0, 16)));
	contentPane.add(catPane);
	contentPane.add(Box.createRigidArea(new Dimension(0, 24)));
	contentPane.add(numPane);
	contentPane.add(Box.createRigidArea(new Dimension(0, 24)));
	contentPane.add(svPane);


	/*
	 * An easy way to put space between a top-level container
	 * and its contents is to put the contents in a JPanel
	 * that has an "empty" border.
	 */
	pane = new JPanel();
	pane.setBorder(BorderFactory.createEmptyBorder(
					10, //top
					10, //left
					10, //bottom
					10) //right
					);
	pane.setLayout(new  GridLayout(0, 1));
	pane.add(contentPane);

	return pane;
    }

    public JMenuBar createMenuBar(global g) {

	JMenuBar pMenuBar = new JMenuBar();
	JMenu submenu0 = new JMenu("Npoint Scan");
	JMenu submenu1 = new JMenu("Move in Steps");
//        JMenu submenu2 = new JMenu("Rolloff");
	JMenu submenu3 = new JMenu("Scans/Line");

	final JRadioButtonMenuItem stepOne = new JRadioButtonMenuItem("One Beamwidth");
	final JRadioButtonMenuItem stepTwo = new JRadioButtonMenuItem("Two Beamwidths");
	final JRadioButtonMenuItem stepFiv = new JRadioButtonMenuItem("Five Beamwidths");
	final JRadioButtonMenuItem stepBig = new JRadioButtonMenuItem("All in One Step");

	final JRadioButtonMenuItem grid3 = new JRadioButtonMenuItem(" 3x3 ");
	final JRadioButtonMenuItem grid5 = new JRadioButtonMenuItem(" 5x5 ");
	final JRadioButtonMenuItem grid7 = new JRadioButtonMenuItem(" 7x7 ");
	final JRadioButtonMenuItem grid9 = new JRadioButtonMenuItem(" 9x9 ");
	final JRadioButtonMenuItem grid11 = new JRadioButtonMenuItem(" 11x11 ");
	final JRadioButtonMenuItem npGrid = new JRadioButtonMenuItem(" Grid ");
	final JRadioButtonMenuItem npAz = new JRadioButtonMenuItem("Azimuth");
	final JRadioButtonMenuItem npEl = new JRadioButtonMenuItem("Elevation");
	final JRadioButtonMenuItem toPeak = new JRadioButtonMenuItem("Move to Peak?");
	toPeak.addItemListener(new ItemListener() {
	    public void itemStateChanged(ItemEvent ie) {
		if (ie.getStateChange() == ItemEvent.SELECTED)
		    npeak = true;
		if (ie.getStateChange() == ItemEvent.DESELECTED)
		    npeak = false;
	    }
	});
	final JRadioButtonMenuItem rptOne = new JRadioButtonMenuItem(" 1 scan/line");
	final JRadioButtonMenuItem rptTwo = new JRadioButtonMenuItem(" 2 scans/line");
	final JRadioButtonMenuItem rptFiv = new JRadioButtonMenuItem(" 5 scans/line");
	final JRadioButtonMenuItem rptTen = new JRadioButtonMenuItem("10 scans/line");
	final JRadioButtonMenuItem rptTty = new JRadioButtonMenuItem("20 scans/line");
	final JRadioButtonMenuItem rptFty = new JRadioButtonMenuItem("50 scans/line");
	final JRadioButtonMenuItem rptHun = new JRadioButtonMenuItem("100 scans/line");

//        final JRadioButtonMenuItem roff8  = new JRadioButtonMenuItem(" 8 Channels");
//        final JRadioButtonMenuItem roff10 = new JRadioButtonMenuItem("10 Channels");
//        final JRadioButtonMenuItem roff12 = new JRadioButtonMenuItem("12 Channels");
//        final JRadioButtonMenuItem roff14 = new JRadioButtonMenuItem("14 Channels");

	ButtonGroup stepGrp = new ButtonGroup();
	stepGrp.add(stepOne);
	stepGrp.add(stepTwo);
	stepGrp.add(stepFiv);
	stepGrp.add(stepBig);
	submenu1.add(stepOne);
	submenu1.add(stepTwo);
	submenu1.add(stepFiv);
	submenu1.add(stepBig);

	ButtonGroup rptGrp = new ButtonGroup();
	rptGrp.add(rptOne);
	rptGrp.add(rptTwo);
	rptGrp.add(rptFiv);
	rptGrp.add(rptTen);
	rptGrp.add(rptTty);
	rptGrp.add(rptFty);
	rptGrp.add(rptHun);
	submenu3.add(rptOne);
	submenu3.add(rptTwo);
	submenu3.add(rptFiv);
	submenu3.add(rptTen);
	submenu3.add(rptTty);
	submenu3.add(rptFty);
	submenu3.add(rptHun);

	ButtonGroup gridGrp = new ButtonGroup();
	gridGrp.add(grid3);
	gridGrp.add(grid5);
	gridGrp.add(grid7);
	gridGrp.add(grid9);
	gridGrp.add(grid11);
	submenu0.add(grid3);
	submenu0.add(grid5);
	submenu0.add(grid7);
	submenu0.add(grid9);
	submenu0.add(grid11);
	submenu0.addSeparator();
	submenu0.add(npGrid);
	submenu0.add(npAz);
	submenu0.add(npEl);
	submenu0.addSeparator();
	submenu0.add(toPeak);

	ButtonGroup formGrp = new ButtonGroup();
	formGrp.add(npGrid);
	formGrp.add(npAz);
	formGrp.add(npEl);

//        ButtonGroup roffGrp = new ButtonGroup();
//        roffGrp.add(roff8);
//        roffGrp.add(roff10);
//        roffGrp.add(roff12);
//        roffGrp.add(roff14);
//        submenu2.add(roff8);
//        submenu2.add(roff10);
//        submenu2.add(roff12);
//        submenu2.add(roff14);

	pMenuBar.add(submenu0);
	pMenuBar.add(submenu1);
//        pMenuBar.add(submenu2);
	pMenuBar.add(submenu3);

	cps = g.get_countperstep();
	cscale = (int)(g.get_beamw() * g.get_azcounts_per_deg());
	if (cps == cscale) {stepOne.setSelected(true);}
	else if (cps == 2 * cscale) {stepTwo.setSelected(true);}
	else if (cps == 5 * cscale) {stepFiv.setSelected(true);}
	else {stepBig.setSelected(true);}

	grid = g.get_grid();
	if (grid == 3) {grid3.setSelected(true);}
	else if (grid == 7) {grid7.setSelected(true);}
	else if (grid == 9) {grid9.setSelected(true);}
	else if (grid == 11) {grid11.setSelected(true);}
	else {grid5.setSelected(true);}

	rpt = g.get_rpt();
	if (rpt == 1) {rptOne.setSelected(true);}
	else if (rpt == 2) {rptTwo.setSelected(true);}
	else if (rpt == 5) {rptFiv.setSelected(true);}
	else if (rpt == 10) {rptTen.setSelected(true);}
	else if (rpt == 20) {rptTty.setSelected(true);}
	else if (rpt == 50) {rptFty.setSelected(true);}
	else {rptHun.setSelected(true);}

//        roff = g.get_rlo();
//        if (roff == 8) {roff8.setSelected(true);}
//        else if (roff == 12) {roff12.setSelected(true);}
//        else if (roff == 14) {roff14.setSelected(true);}
//        else {roff10.setSelected(true);}

	npaz = g.get_npaz();
	npel = g.get_npel();
	if (npaz && !npel) {npAz.setSelected(true);}
	else if (!npaz && npel) {npEl.setSelected(true);}
	else {npGrid.setSelected(true);}

	toPeak.setSelected((peak = g.get_topk()));


	return pMenuBar;
    }

    public void update(global g) {

	sazField.setText(outF1.format(g.get_sunaz()));
	selField.setText(outF1.format(g.get_sunel()));
	if (g.get_scan() > 0 || g.get_bsw() != 0
	    || g.get_stow() == 1 || g.get_cmdf() > 0)
		saveChangeBut.setEnabled(false);
	else
	    saveChangeBut.setEnabled(true);
    }

    public void refresh(global g) {

	JMenu gm0 = pMenuBar.getMenu(0);
	JMenuItem g3 = gm0.getItem(0);
	JMenuItem g5 = gm0.getItem(1);
	JMenuItem g7 = gm0.getItem(2);
	JMenuItem g9 = gm0.getItem(3);
	JMenuItem g11 = gm0.getItem(4);
	// separator in here
	JMenuItem npg = gm0.getItem(6);
	JMenuItem npa = gm0.getItem(7);
	JMenuItem npe = gm0.getItem(8);
	// separator in here
	JMenuItem tp = gm0.getItem(10);
	JMenu gm1 = pMenuBar.getMenu(1);
	JMenuItem s1 = gm1.getItem(0);
	JMenuItem s2 = gm1.getItem(1);
	JMenuItem s5 = gm1.getItem(2);
	JMenuItem sb = gm1.getItem(3);
//        JMenu gm2 = pMenuBar.getMenu(2);
//        JMenuItem r8 = gm2.getItem(0);
//        JMenuItem r10 = gm2.getItem(1);
//        JMenuItem r12 = gm2.getItem(2);
//        JMenuItem r14 = gm2.getItem(3);
	JMenu gm3 = pMenuBar.getMenu(2);
	JMenuItem r1 = gm3.getItem(0);
	JMenuItem r2 = gm3.getItem(1);
	JMenuItem r5 = gm3.getItem(2);
	JMenuItem r10 = gm3.getItem(3);
	JMenuItem r20 = gm3.getItem(4);
	JMenuItem r50 = gm3.getItem(5);
	JMenuItem r100 = gm3.getItem(6);

	tp.setSelected((peak = g.get_topk()));

	npaz = g.get_npaz();
	npel = g.get_npel();
	if (npaz && !npel) {npa.setSelected(true);}
	else if (!npaz && npel) {npe.setSelected(true);}
	else {npg.setSelected(true);}

	grid = g.get_grid();
	if (grid == 3) {g3.setSelected(true);}
	else if (grid == 7) {g7.setSelected(true);}
	else if (grid == 9) {g9.setSelected(true);}
	else if (grid == 11) {g11.setSelected(true);}
	else {g5.setSelected(true);}

	rpt = g.get_rpt();
	if (rpt == 1) {r1.setSelected(true);}
	else if (rpt == 2) {r2.setSelected(true);}
	else if (rpt == 5) {r5.setSelected(true);}
	else if (rpt == 10) {r10.setSelected(true);}
	else if (rpt == 20) {r20.setSelected(true);}
	else if (rpt == 50) {r50.setSelected(true);}
	else {r100.setSelected(true);}

//        roff = g.get_rlo();
//        if (roff == 8) {r8.setSelected(true);}
//        else if (roff == 12) {r12.setSelected(true);}
//        else if (roff == 14) {r14.setSelected(true);}
//        else {r10.setSelected(true);}

	cps = g.get_countperstep();
	cscale = (int)(g.get_beamw() * g.get_azcounts_per_deg());
	if (cps == cscale) {s1.setSelected(true);}
	else if (cps == 2 * cscale) {s2.setSelected(true);}
	else if (cps == 5 * cscale) {s5.setSelected(true);}
	else {sb.setSelected(true);}

	if (g.get_tnsou() >= 0) {
	    tras = (180.0/Math.PI)*(g.get_ras(g.get_tnsou()));
	    tdecs = (180.0/Math.PI)*(g.get_decs(g.get_tnsou()));
	    tazField.setText(outF1.format(tras));
	    telField.setText(outF1.format(tdecs));
	}
	sazField.setText(outF1.format(g.get_sunaz()));
	selField.setText(outF1.format(g.get_sunel()));
	paoField.setText(pao=outF1.format(g.get_pazoff()));
	peoField.setText(peo=outF1.format(g.get_peloff()));
	tsField.setText(syst=outF1.format(g.get_tsys()));
	ntField.setText(noiset=outF1.format(g.get_noisecal()));
	ccField.setText(calc=outS3.format(g.get_calcons()));
	cvField.setText(curv=outS3.format(g.get_curvcorr()));
	cmdBut.setSelected(g.get_cmdf() == 1);
	cmdField.setText(cfile=g.get_cmdfile());

	recBut.setSelected(g.get_fstatus() == 1);
	recField.setText(rfile=g.get_recfile());
	rmode = g.get_recmode();
	if ((rmode | 1) == 1) tabBut.setSelected(true);
	else if ((rmode | 8) == 8) comBut.setSelected(true);
	else spcBut.setSelected(true);

	logBut.setSelected(g.get_elog());
	logField.setText(lfile=g.get_elgfile());
	catField.setText(g.get_catfn());

	if (g.get_scan() > 0 || g.get_bsw() != 0
	    || g.get_stow() == 1 || g.get_cmdf() > 0)
		saveChangeBut.setEnabled(false);
	else
	    saveChangeBut.setEnabled(true);

	g.set_pref(false);
    }
}

