import javax.swing.*;    // JDL for params, pframe
import java.awt.*;
import java.awt.event.*; // JDL for pframe WindowListener
import java.util.Properties;

// main class that starts main thread loop 
// this code evolved from a C program and is not modular 
// an ongoing task is to provided a more modular version 
// allowing for easier addition of modules 
// since this code is not modular we recommend that find or 
// grep always be used when making changes to check for all 
// occurances of globals 
public class srt
{
    // JDL: these were made static and placed outside main()
    // so they could be used to show & hide pframe
    static disp d;
    static global g;
    static outfile out;
    static params parm = null;   // JDL
    static JFrame pframe = null; // JDL
    static Properties props;     // JDL
    static startup dstart = null; // JDL
    static JFrame dsframe = null; // JDL

    public static void main(String args[]) {
	time t;
	String fs = "/";
	String os = "unknown";
        String ydhms;
	String ver = "2.06";
        long sec, secp;
	double secstop;
        int i;
	sockport s;
//JDL        usb2820 u;
	procs proc;
	checkey che = new checkey();
        cat cat = new cat();
        Graphics gg;
	props = new Properties(System.getProperties());
	os = props.getProperty("os.name");
//        System.out.println("OS="+os);
	g = new global();
	g.set_ver(ver);
	if (os.regionMatches(true, 0, "win", 0, 3))
	    g.set_os("windows");
	else if (os.regionMatches(true, 0, "lin", 0, 3))
	    g.set_os("linux");
	else if (os.regionMatches(true, 0, "mac", 0, 3))
	    g.set_os("macosx");
	else
	    g.set_os("unknown");
	fs = props.getProperty("file.separator");
	g.set_uhomed(props.getProperty("user.home") + fs);
//        System.out.println("$HOME="+g.get_uhomed());

	g.set_catfn("srt.cat"); //JDL
	g.set_elog(true);       //JDL (log errors)
	g.set_logsyserr(true);  //JDL (System.err to log file if open)
	g.open_elog();          //JDL (uses default name)
	g.set_host("18.109.0.104");//JDL (default socket host)
	g.set_port(1421);       //JDL (default socket port)
	g.set_stamp(false);     //JDL (default Stamp 1 code is mtrnew5.bas)
	g.set_match(0);         //JDL mode 4 matching in procs.java
	g.set_recmode(1);       //JDL default tab separator
	g.set_rpt(1);           //JDL how many scans at each npoint
	g.set_noisecal(115.0);
        g.set_curvcorr(0.0);
        g.set_ptoler(1);
// put is some MIT defaults incase there is no srt.cat file - JDL
        g.set_countperstep(10000); // default large number for no stepping  
        g.set_azcounts_per_deg(8.0 * 32.0 * 60.0 / (360.0 * 9.0)); // default for CASSI 
        g.set_elcounts_per_deg(52.0 * 27.0 / 120.0); // default for H-180 
        g.set_pushrod(1);       // default to CASSI 
        g.set_rod1(14.25);      // rigid arm length 
	g.set_rod2(16.5);       // distance from pushrod upper joint to el axis
        g.set_rod3(2.0);        // pushrod collar offset 
        g.set_rod4(110.0);      // angle at horizon 
        g.set_rod5(30.0);       // pushrod counts per inch 
        g.set_hh90(0);
        g.set_sg2100(0);
	g.set_lat(42.361);
	g.set_lon(71.091);
	g.set_statnam("MIT");
	g.set_mancal(-1);
	g.set_digital(1);
	g.set_freqsep(0.0078125);
	g.set_intg(0.52488);
	g.set_nfreq(64);
	g.set_elog(true);

// custom dialog to get start parameters
	g.set_azelsim(-1);  // JDL default
	g.set_radiosim(-1); // JDL default
	g.set_mainten(0);   // JDL default
	dstart = new startup(); // JDL
	if (dstart != null) {
	    dsframe = dstart.makeFrame(g);
	    dsframe.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    System.exit(0);
		}
	    });
	    dsframe.setLocation(64, 216);
	}
	while (g.get_radiosim() < 0) { // kluge to make it modal
	    dsframe.setVisible(true);
	    dsframe.toFront();
	    try {
		Thread.sleep(1000);
	    } catch(InterruptedException ie) {
		// do nothing
	    }
	}
	dsframe.setVisible(false);

	t = new time();
	out = new outfile(t);
	d = new disp("srt - version " + ver
	    + " ($HOME=" + g.get_uhomed() + ")", g, out, che);
	d.setLocation(36, 36);  //JDL, position window on screen
        gg = d.getGraphics();
        che.set_graph(gg);

        for (i = 0; i < 100; i++) {
            g.set_xlast(1, i);
            g.set_ylast(1, i);
        }
        for (i = 0; i < 360; i++) {
            g.set_gxlast(1, i);
            g.set_gylast(1, i);
        }
	g.set_nfreq(64);   // JDL, default for digital rcvr
	g.set_doparams(0); // JDL
	g.set_grid(5);     // JDL
	g.set_npaz(true);  // JDL
	g.set_npel(true);  // JDL
	g.set_topk(false); // JDL
	g.set_azlim1(10.0);  // JDL for MIT CASSI mount } these let program
	g.set_azlim2(359.0); // JDL for MIT CASSI mount } start with no cat
	g.set_ellim1(1.0);   // JDL for MIT CASSI mount } file
	g.set_ellim2(90.0);  // JDL for MIT CASSI mount }
        g.set_calcons(1.0);
        g.set_tload(300.0);
        g.set_tspill(20.0);
	g.set_beamw(7.0);
        g.set_pscale(400.0);
        g.set_comerr(0);
        g.set_comerad(0);
        g.set_fcenter(1420.0);  /* default for continuum */
	g.set_freqa(1420.0);
        g.set_restfreq(1420.406); /* H-line restfreq */
        if (g.get_radiosim() != 0) {
            g.set_fcenter(1420.4); /* default for H-line */
	    //g.set_nfreq(40); //JDL set for digital above
        }
	g.set_tnsou(-1); // index for AZEL "TEST"
        g.set_ppos(0);
        g.set_azoff(0.0);
        g.set_eloff(0.0);
        g.set_pazoff(0.0);
        g.set_peloff(0.0);
	g.set_tdoff(0.0);
	g.set_thoff(0.0);
        g.set_elback(0.0);
        g.set_drift(0);
        secstop = 0.0;
        secp = 0;
        g.set_tstart(0);
        g.set_azaxis_tilt(0.0);
        g.set_tilt_az(0.0);
        g.set_elaxis_tilt(0.0);
        g.set_azfeed_offset(0.0);
        g.set_tsys(0.0);
        g.set_stopproc(0);
        g.set_click(0);
        g.set_mclick(0);
        g.set_atten(0);
        g.set_calon(0);
        g.set_docal(0);
        g.set_sourn(0);
        g.set_track(0);
        g.set_scan(0);
        g.set_bsw(0);
        g.set_clr(1);
	g.set_rlo(10);            // JDL for digital rcvr roll-off
	g.set_digital(1);         // JDL default for digital rcvr
	g.set_freqsep(0.0078125); // JDL default for digital rcvr
	g.set_intg(0.52488);      // JDL default for digital rcvr
        g.set_fstatus(0);
        g.set_cmdf(0);
        g.set_key(0);
	g.set_recform(1);         // JDL default for TAB field separator
        g.set_sig(1);
	g.set_vsrt(0);
        g.set_visoc(0);
        g.set_debug(0);
	cat.catfile(g, d, gg);
        d.set_font(gg);
        if (g.get_debug() == 1)
            System.out.println("finished cat");
        if (g.get_azlim2() > g.get_azlim1() && g.get_azlim2() < 360.0)
            g.set_south(1);     /* normally South */
        else {
            g.set_south(0);     /* North */
            if (g.get_azlim2() < 360.0)
                g.set_azlim2(g.get_azlim2() + 360.0);
        }
	parm = new params(); // JDL
	if (parm != null) {
	    pframe = parm.makeFrame(g, d, out, cat);
	    pframe.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    hide_pframe();
		}
	    });
	    pframe.setLocation(24, 216);
	}
	s = new sockport(g);
	d.set_sockport(s);
	proc = new procs(s, out);
        if (g.get_digital() != 0)
	    proc.grayfilt(g); // loads the digital receiver filter table




/* JDL note: original code only went to stow on startup if mainten==0,
 * but often you want to do maintenance because the antenna stopped at
 * a point that is not the stow position. Sending it to stow first will
 * recalibrate the coordinates so that mainten==1 sends it where you
 * expect, and it only wastes a small amount of time if the antenna is
 * already at stow.
 * The other behavior change with mainten!=0 is that errors in
 * sockport.azel() do not send the antenna back to stow.
 */
	g.set_azcmd(g.get_azstow());
	g.set_elcmd(g.get_elstow());
	g.set_azcount(0);
	g.set_elcount(0);
	g.set_stow(1);
	if (g.get_mainten() != 0) {
            if (g.get_south() == 1) {
                g.set_azcmd(180.0);
                g.set_aznow(180.0);
            } else {
                g.set_azcmd(360.0);
                g.set_aznow(360.0);
            }
            g.set_elcmd(45.0);
            g.set_elnow(45.0);
            g.set_azcount((int) ((g.get_aznow() - g.get_azlim1()) * g.get_azcounts_per_deg()));
            g.set_elcount((int) ((g.get_elnow() - g.get_ellim1()) * g.get_elcounts_per_deg()));
            g.set_stow(0);
        }

        while (true) {
	    // java.awt.Toolkit.getDefaultToolkit().beep(); makes a beep
	    if (g.get_beep()) {
		g.set_beep(false);
		java.awt.Toolkit.getDefaultToolkit().beep();
	    }
            if (g.get_click() != 0) {
                if (g.get_cmdstr().length() > 1)
                    g.set_click(0);
                che.checky(g, d, gg, out);
                if (g.get_click() == 1)
                    g.set_click(0);
            }
            if (g.get_docal() == 1)
                proc.calibrat(g, d, gg, out);
            if (g.get_docal() == 2) {
		if (g.get_vsrt() == 0) {
                    proc.noisecal(g, d, gg, out);
		    parm.refresh(g);
		}
                else
                    g.set_docal(0);
            }
	    if (g.get_doparams() == 2 && g.get_pvis() == false)
		show_pframe();
	    else if (g.get_doparams() == 1 && g.get_pvis() == true)
		hide_pframe();
	    parm.update(g);
	    proc.spectra(g, d, gg);
            sec = t.getTsec(g, d, gg);
            if (g.get_cmdf() == 1) {
                if (sec > secstop && g.get_slew() == 0 && g.get_scan() == 0)
                    secstop = cat.cmdfile(g, d, gg, t, out);
            } else
                secstop = 0.0;
	    if (((g.get_recform() & 4) == 4) && sec / 86400 > secp / 86400
		&& g.get_fstatus() == 1) {
                out.closeoutfile(g, d, gg);
                if (g.get_fstatus() == 0)
                    out.openoutfile(g, d, gg);
                secp = sec;
            }
        }

    }

    private static void show_pframe() { //JDL
	if (parm == null || pframe == null) return;
	parm.refresh(g);
	pframe.setVisible(true);
	pframe.toFront();
	g.set_pvis(true);
	d.set_bc(Color.green, 1);
    }

    private static void hide_pframe() { //JDL
	if (parm != null)
	    pframe.setVisible(false);
	d.set_bc(Color.black, 1);
	g.set_pvis(false);
	g.set_doparams(0);
    }

}
