// displays the value of selected parameters
// and allows users to change them
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.color.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import java.lang.Math;


public class startup
{

    private JCheckBox asim;     // simulate antenna
    private JCheckBox rsim;     // simulate radip
    private JCheckBox mbox;     // maintenance mode
    private DefaultListModel tsfacts;   // time speed up factors
    private JCheckBox toff;     // to allow time offsets
    private JButton runBut;
    private JList speeds;
    private JLabel infoLabel;
    private JLabel spLabel;
    private JLabel verLabel;
    private int maintain = 0;
    private int sfactor = 1;
    private int simazel = 0;
    private int simradio = 0;
    private static boolean toffOK = false;

    public static JFrame myFrame;

    public JFrame makeFrame(final global g) {
	myFrame = new JFrame("Start the SRT:");
	Component contents = createComponents(g);
	myFrame.getContentPane().add(contents, BorderLayout.CENTER);
	myFrame.pack();
	return myFrame;
    }

    private Component createComponents(final global g) {

	asim = new JCheckBox("Simulate Antenna Motion");
	asim.getAccessibleContext().setAccessibleDescription(
	    "Simulate antenna motion.");
	asim.setSelected(false);
	asim.addItemListener(new ItemListener() {
	    public void itemStateChanged(ItemEvent ie) {
		if (ie.getStateChange() == ItemEvent.SELECTED) {
		    simazel = 1;
		} else {
		    simazel = 0;
		}
	    }
	});
	JPanel asimPane = new JPanel();
	asimPane.setLayout(new BoxLayout(asimPane, BoxLayout.X_AXIS));
	asimPane.add(asim);
	asimPane.add(Box.createHorizontalGlue());

	rsim = new JCheckBox("Simulate Radio Signals");
	rsim.getAccessibleContext().setAccessibleDescription(
	    "Simulate radio signals.");
	rsim.setSelected(false);
	rsim.addItemListener(new ItemListener() {
	    public void itemStateChanged(ItemEvent ie) {
		if (ie.getStateChange() == ItemEvent.SELECTED) {
		    simradio = 1;
		} else {
		    simradio = 0;
		}
	    }
	});
	JPanel rsimPane = new JPanel();
	rsimPane.setLayout(new BoxLayout(rsimPane, BoxLayout.X_AXIS));
	rsimPane.add(rsim);
	rsimPane.add(Box.createHorizontalGlue());

	mbox = new JCheckBox("Start in Maintenance Mode");
	mbox.getAccessibleContext().setAccessibleDescription(
	    "Start in maintenance mode.");
	mbox.setSelected(false);
	mbox.addItemListener(new ItemListener() {
	    public void itemStateChanged(ItemEvent ie) {
		if (ie.getStateChange() == ItemEvent.SELECTED) {
		    maintain = 1;
		} else {
		    maintain = 0;
		}
	    }
	});
	JPanel mboxPane = new JPanel();
	mboxPane.setLayout(new BoxLayout(mboxPane, BoxLayout.X_AXIS));
	mboxPane.add(mbox);
	mboxPane.add(Box.createHorizontalGlue());

	tsfacts = new DefaultListModel();
	tsfacts.addElement("Normal");
	tsfacts.addElement("2 times");
	tsfacts.addElement("5 times");
	tsfacts.addElement("10 times");
	tsfacts.addElement("20 times");
	tsfacts.addElement("50 times");
	tsfacts.addElement("100 times");
	speeds = new JList(tsfacts);
	speeds.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	speeds.setSelectedIndex(0);
	speeds.setVisibleRowCount(3);
	JScrollPane speedScrollPane = new JScrollPane(speeds);
	speedScrollPane.setPreferredSize(new Dimension(128, 54));
	speeds.addListSelectionListener(new ListSelectionListener() {
	    public void valueChanged(ListSelectionEvent e) {
//                if (asim.isSelected() == true) {
		    switch (speeds.getSelectedIndex()) {
			case 0:
			    sfactor = 1; break;
			case 1:
			    sfactor = 2; break;
			case 2:
			    sfactor = 5; break;
			case 3:
			    sfactor = 10; break;
			case 4:
			    sfactor = 20; break;
			case 5:
			    sfactor = 50; break;
			case 6:
			    sfactor = 50; break;
			default:
			    sfactor = 1;
		    }
//                }
	    }
	});

	spLabel = new JLabel("Choose clock speed factor:");
	JPanel splPane = new JPanel();
	splPane.setLayout(new BoxLayout(splPane, BoxLayout.X_AXIS));
	splPane.add(spLabel);
	splPane.add(Box.createHorizontalGlue());

	toff = new JCheckBox("Allow Clock Offset");
	toff.getAccessibleContext().setAccessibleDescription(
	    "Speed up the clock.");
	toff.setSelected(false);
	toffOK = false;
	toff.addItemListener(new ItemListener() {
	    public void itemStateChanged(ItemEvent ie) {
		if (ie.getStateChange() == ItemEvent.SELECTED) {
		    toffOK = true;
//                    if (simazel > 0)
//                        simazel *= -1;
		} else { // DESELECTED
		    toffOK = false;
//                    if (simazel < 0)
//                        simazel *= -1;
		}
	    }
	});
	JPanel toffPane = new JPanel();
	toffPane.setLayout(new BoxLayout(toffPane, BoxLayout.X_AXIS));
	toffPane.add(toff);
	toffPane.add(Box.createHorizontalGlue());

	JPanel rbPane = new JPanel();
	rbPane.setLayout(new BoxLayout(rbPane, BoxLayout.X_AXIS));
	runBut = new JButton("Run Program");
	runBut.getAccessibleContext().setAccessibleDescription(
	    "Start the program.");
	runBut.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		if (asim.isSelected() == true) {
		    simazel = sfactor;
		    if (toffOK == true) {
			simazel = -Math.abs(simazel);
		    }
		} else {
		    simazel = 0;
		}
		if (rsim.isSelected() == true) {
		    simradio = 1;
		}
		g.set_azelsim(simazel);
		g.set_radiosim(simradio);
		if (maintain != 0)
		    g.set_mainten(maintain);
	    }
	});
	rbPane.add(Box.createHorizontalGlue());
	rbPane.add(runBut);
	rbPane.add(Box.createHorizontalGlue());

	infoLabel = new JLabel("$HOME="+g.get_uhomed());
	Font aaaFont = infoLabel.getFont();
	Font infofont = aaaFont.deriveFont(10.0f);
	infoLabel.setFont(infofont);
	JPanel infoPane = new JPanel();
	infoPane.setLayout(new BoxLayout(infoPane, BoxLayout.X_AXIS));
//        infoPane.add(Box.createHorizontalGlue());
	infoPane.add(infoLabel);
	infoPane.add(Box.createHorizontalGlue());

	verLabel = new JLabel("(srt version "+g.get_ver()+")");
	verLabel.setFont(infofont);
	JPanel verPane = new JPanel();
	verPane.setLayout(new BoxLayout(verPane, BoxLayout.X_AXIS));
	verPane.add(Box.createHorizontalGlue());
	verPane.add(verLabel);
	verPane.add(Box.createHorizontalGlue());

	JPanel vPane = new JPanel();
	vPane.setLayout(new BoxLayout(vPane, BoxLayout.Y_AXIS));
	vPane.add(verPane);
	vPane.add(Box.createVerticalStrut(4));
	vPane.add(infoPane);
	vPane.add(asimPane);
	vPane.add(rsimPane);
	vPane.add(mboxPane);
	vPane.add(toffPane);
	vPane.add(splPane);
	vPane.add(speedScrollPane);
	vPane.add(Box.createVerticalStrut(6));
	vPane.add(rbPane);

	JPanel pane = new JPanel();
	pane.setBorder(BorderFactory.createEmptyBorder(
					10, //top
					10, //left
					10, //bottom
					10) //right
					);
	pane.setLayout(new  GridLayout(0, 1));
//        pane.add(contentPane);
	pane.add(vPane);

	return pane;
    }



}
